# @signalwire/js

# RELAY Browser SDK

[![The build status of the package @signalwire/js.](https://ci.signalwire.com/api/badges/signalwire/signalwire-js/status.svg)](https://ci.signalwire.com/signalwire/signalwire-js) ![The NPM shield for the package @signalwire/js.](https://img.shields.io/npm/v/@signalwire/js.svg?color=brightgreen)

The RELAY Browser SDK transforms your standard browser into a realtime media engine, enabling developers to directly make audio and video calls to phone numbers, SIP endpoints, and other browsers. Using the JavaScript SDK you can add immersive, scalable communication - from video conferences and softphones to click-to-call and mobile gaming - all available right in your own web pages and applications.

SignalWire's simple and powerful authentication system, using JWT, allows you to set granular permissions, enabling some of your users to only join conference calls, while others could list on-going calls and jump in to assist from a support dashboard... the possibilities are endless.

## Getting Started

Read the implementation documentation, guides and API Reference at the official [SignalWire JavaScript SDK Documentation](https://developer.signalwire.com/sdks/reference/browser-sdk) site.

---

## Contributing

SignalWire JavaScript SDK is open source and maintained by the SignalWire team, but we are very grateful for [everyone](https://github.com/signalwire/signalwire-js/contributors) who has contributed and assisted so far.

If you'd like to contribute, feel free to visit our [Slack channel](https://signalwire.community/) and read our developer section to get the code running in your local environment.

## Developers

The JavaScript SDK is a package inside the [signalwire-js](https://github.com/signalwire/signalwire-js) _monorepo_. To setup the dev environment follow these steps:

1. [Download the installer](https://nodejs.org/) for the LTS version of Node.js. This is the best way to also [install npm](https://blog.npmjs.org/post/85484771375/how-to-install-npm#_=_).
2. Fork the [signalwire-js](https://github.com/signalwire/signalwire-js) repository and clone it.
3. Create a new branch from `main` for your change.
4. Run `npm install` to install global dependencies.
5. Navigate into the JavaScript directory with `cd packages/js`.
6. Make changes!

## Versioning

SignalWire JavaScript SDK follows Semantic Versioning 2.0 as defined at [http://semver.org](http://semver.org).

## License

`@signalwire/js` is copyright © 2018-2023 [SignalWire](http://signalwire.com). It is free software, and may be redistributed under the terms specified in the [MIT-LICENSE](https://github.com/signalwire/signalwire-js/blob/master/LICENSE) file.
