"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __reflectGet = Reflect.get;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
var __superGet = (cls, obj, key) => __reflectGet(__getProtoOf(cls), key, obj);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// src/index.ts
var index_exports = {};
__export(index_exports, {
  Chat: () => chat_exports,
  Fabric: () => fabric_exports,
  LocalVideoOverlay: () => LocalVideoOverlay,
  PubSub: () => pubSub_exports,
  SignalWire: () => SignalWire,
  UserOverlay: () => UserOverlay,
  Video: () => video_exports,
  WebRTC: () => webrtc_exports,
  buildVideoElement: () => buildVideoElement
});
module.exports = __toCommonJS(index_exports);

// src/chat/index.ts
var chat_exports = {};
__export(chat_exports, {
  ChatMember: () => import_core35.ChatMember,
  ChatMessage: () => import_core35.ChatMessage,
  Client: () => Client2
});

// src/createClient.ts
var import_core34 = require("@signalwire/core");

// src/Client.ts
var import_core31 = require("@signalwire/core");

// src/features/mediaElements/mediaElementsSagas.ts
var import_core2 = require("@signalwire/core");
var import_webrtc = require("@signalwire/webrtc");

// src/utils/audioElement.ts
var setAudioMediaTrack = ({
  track,
  element
}) => {
  element.autoplay = true;
  element.playsinline = true;
  element.srcObject = new MediaStream([track]);
  track.addEventListener("ended", () => {
    element.srcObject = null;
    element.remove();
  });
  return element;
};

// src/features/actions.ts
var import_core = require("@signalwire/core");
var audioSetSpeakerAction = import_core.actions.createAction(
  "swJs/audioSetSpeakerAction"
);

// src/features/mediaElements/mediaElementsSagas.ts
var makeAudioElementSaga = ({ speakerId }) => {
  return function* audioElementSaga({
    instance: room,
    runSaga
  }) {
    if (typeof Audio === "undefined") {
      (0, import_core2.getLogger)().warn("`Audio` is not supported on this environment.");
      return;
    }
    try {
      const audioEl = room.getAudioEl();
      let audioTask;
      const trackHandler = function(event) {
        switch (event.track.kind) {
          case "audio": {
            audioTask = runSaga(audioElementSetupWorker, {
              track: event.track,
              element: audioEl,
              speakerId,
              room
            });
            break;
          }
        }
      };
      room.on("track", trackHandler);
      room.once("destroy", () => {
        audioTask == null ? void 0 : audioTask.cancel();
      });
    } catch (error) {
      (0, import_core2.getLogger)().error("audioElementSaga", error);
    }
  };
};
function* audioElementActionsWatcher({
  element,
  room
}) {
  const setSpeakerActionType = import_core2.actions.getCustomSagaActionType(
    room.__uuid,
    audioSetSpeakerAction
  );
  while (true) {
    const action = yield import_core2.sagaEffects.take([setSpeakerActionType]);
    try {
      switch (action.type) {
        case setSpeakerActionType:
          const response = yield import_core2.sagaEffects.call(
            import_webrtc.setMediaElementSinkId,
            element,
            action.payload
          );
          room.emit(
            // @ts-expect-error
            `${import_core2.LOCAL_EVENT_PREFIX}.speaker.updated`,
            action.payload
          );
          room.settleCustomSagaTrigger({
            dispatchId: action.dispatchId,
            payload: response,
            kind: "resolve"
          });
          break;
      }
    } catch (error) {
      room.settleCustomSagaTrigger({
        dispatchId: action.dispatchId,
        payload: error,
        kind: "reject"
      });
      (0, import_core2.getLogger)().error(error);
    }
  }
}
function* audioElementSetupWorker({
  track,
  element,
  speakerId,
  room
}) {
  setAudioMediaTrack({ track, element });
  if (speakerId) {
    (0, import_webrtc.setMediaElementSinkId)(element, speakerId).catch(() => {
    });
  }
  yield import_core2.sagaEffects.fork(audioElementActionsWatcher, {
    element,
    room
  });
}

// src/cantina/VideoManager.ts
var import_core6 = require("@signalwire/core");

// src/cantina/workers/videoManagerWorker.ts
var import_core5 = require("@signalwire/core");

// src/cantina/workers/videoManagerRoomsWorker.ts
var import_core3 = require("@signalwire/core");
var videoManagerRoomsWorker = function* (options) {
  (0, import_core3.getLogger)().trace("videoManagerRoomsWorker started");
  const {
    instance: client,
    action: { type, payload }
  } = options;
  const modPayload = {
    rooms: payload.rooms.map((row) => (0, import_core3.toExternalJSON)(row))
  };
  client.emit(
    (0, import_core3.stripNamespacePrefix)(type),
    // @ts-expect-error
    modPayload
  );
  (0, import_core3.getLogger)().trace("videoManagerRoomsWorker ended");
};

// src/cantina/workers/videoManagerRoomWorker.ts
var import_core4 = require("@signalwire/core");
var videoManagerRoomWorker = function* (options) {
  (0, import_core4.getLogger)().trace("videoManagerRoomWorker started");
  const {
    instance: client,
    action: { type, payload }
  } = options;
  client.emit(
    (0, import_core4.stripNamespacePrefix)(type),
    (0, import_core4.toExternalJSON)(payload)
  );
  (0, import_core4.getLogger)().trace("videoManagerRoomWorker ended");
};

// src/cantina/workers/videoManagerWorker.ts
var videoManagerWorker = function* (options) {
  (0, import_core5.getLogger)().trace("videoManagerWorker started");
  const {
    channels: { swEventChannel }
  } = options;
  function* worker(action) {
    const { type } = action;
    switch (type) {
      case "video-manager.rooms.subscribed":
        yield import_core5.sagaEffects.fork(videoManagerRoomsWorker, __spreadValues({
          action
        }, options));
        break;
      case "video-manager.room.added":
      case "video-manager.room.deleted":
      case "video-manager.room.ended":
      case "video-manager.room.started":
      case "video-manager.room.updated":
        yield import_core5.sagaEffects.fork(videoManagerRoomWorker, __spreadValues({
          action
        }, options));
        break;
      default:
        (0, import_core5.getLogger)().warn(`Unknown video-manager event: "${type}"`);
        break;
    }
  }
  while (true) {
    const action = yield import_core5.sagaEffects.take(
      swEventChannel,
      (action2) => {
        return action2.type.startsWith("video-manager.");
      }
    );
    yield import_core5.sagaEffects.fork(worker, action);
  }
  (0, import_core5.getLogger)().trace("videoManagerWorker ended");
};

// src/cantina/VideoManager.ts
var VideoManagerAPI = class extends import_core6.BaseConsumer {
  constructor(options) {
    super(options);
    this.runWorker("videoManagerWorker", {
      worker: videoManagerWorker
    });
  }
  /** @internal */
  getSubscriptions() {
    const eventNamesWithPrefix = this.eventNames().map(
      (event) => `video-manager.${event}`
    );
    return (0, import_core6.validateEventsToSubscribe)(eventNamesWithPrefix);
  }
};
var createVideoManagerObject = (params) => {
  const manager = (0, import_core6.connect)({
    store: params.store,
    Component: VideoManagerAPI
  })(params);
  const proxy = new Proxy(manager, {
    get(target, property, receiver) {
      if (property === "_eventsNamespace") {
        return "";
      } else if (property === "eventChannel") {
        return "video-manager.rooms";
      }
      return Reflect.get(target, property, receiver);
    }
  });
  return proxy;
};

// src/buildVideoElement.ts
var import_core30 = require("@signalwire/core");

// src/utils/videoElement.ts
var import_core29 = require("@signalwire/core");

// src/VideoOverlays.ts
var import_core28 = require("@signalwire/core");

// src/video/VideoRoomSession.ts
var import_core17 = require("@signalwire/core");

// src/BaseRoomSession.ts
var import_core15 = require("@signalwire/core");
var import_webrtc3 = require("@signalwire/webrtc");

// src/utils/constants.ts
var SCREENSHARE_AUDIO_CONSTRAINTS = {
  echoCancellation: true,
  noiseSuppression: false,
  autoGainControl: false,
  // @ts-expect-error
  googAutoGainControl: false
};

// src/utils/roomSession.ts
var import_core7 = require("@signalwire/core");
var getJoinMediaParams = (options) => {
  const {
    authState,
    audio = true,
    video = true,
    sendAudio,
    sendVideo,
    receiveAudio,
    receiveVideo
  } = options;
  (0, import_core7.getLogger)().debug("getJoinMediaParams options", __spreadValues({}, options));
  const { audio_allowed, video_allowed, join_as } = authState;
  const joinAs = join_as != null ? join_as : "member";
  const canSend = joinAs === "member";
  const canSendAudio = canSend && audio_allowed === "both";
  const canSendVideo = canSend && video_allowed === "both";
  const canReceiveAudio = audio_allowed !== "none";
  const canReceiveVideo = video_allowed !== "none";
  const reqToSendAudio = Boolean(sendAudio != null ? sendAudio : audio);
  const reqToSendVideo = Boolean(sendVideo != null ? sendVideo : video);
  const reqToReceiveAudio = Boolean(receiveAudio != null ? receiveAudio : audio);
  const reqToReceiveVideo = Boolean(receiveVideo != null ? receiveVideo : video);
  if (!canSendAudio && reqToSendAudio) {
    (0, import_core7.getLogger)().info(
      "Not allowed to send audio on this room. Default values will be used."
    );
  }
  if (!canSendVideo && reqToSendVideo) {
    (0, import_core7.getLogger)().info(
      "Not allowed to send video on this room. Default values will be used."
    );
  }
  if (!canReceiveAudio && reqToReceiveAudio) {
    (0, import_core7.getLogger)().info(
      "Not allowed to receive video from the room. Default values will be used."
    );
  }
  if (!canReceiveVideo && reqToReceiveVideo) {
    (0, import_core7.getLogger)().info(
      "Not allowed to receive video from the room. Default values will be used."
    );
  }
  return {
    mustSendAudio: canSendAudio && reqToSendAudio,
    mustSendVideo: canSendVideo && reqToSendVideo,
    mustRecvAudio: canReceiveAudio && reqToReceiveAudio,
    mustRecvVideo: canReceiveVideo && reqToReceiveVideo
  };
};
var checkMediaParams = (options) => {
  return Object.values(options).some(Boolean);
};
var SDK_PREFIX = "sw-sdk-";
var addSDKPrefix = (id) => {
  return `${SDK_PREFIX}${id}`;
};
var OVERLAY_PREFIX = "sw-overlay-";
var addOverlayPrefix = (id) => {
  return `${OVERLAY_PREFIX}${id}`;
};

// src/RoomSessionScreenShare.ts
var import_core8 = require("@signalwire/core");
var import_webrtc2 = require("@signalwire/webrtc");
var RoomSessionScreenShareConnection = class extends import_webrtc2.BaseConnection {
  join() {
    return super.invite();
  }
  leave() {
    return super.hangup();
  }
};
var RoomSessionScreenShareAPI = (0, import_core8.extendComponent)(RoomSessionScreenShareConnection, {
  audioMute: import_core8.Rooms.audioMuteMember,
  audioUnmute: import_core8.Rooms.audioUnmuteMember,
  videoMute: import_core8.Rooms.videoMuteMember,
  videoUnmute: import_core8.Rooms.videoUnmuteMember,
  setMicrophoneVolume: import_core8.Rooms.setInputVolumeMember,
  setInputVolume: import_core8.Rooms.setInputVolumeMember,
  setInputSensitivity: import_core8.Rooms.setInputSensitivityMember
});

// src/video/workers/memberListUpdatedWorker.ts
var import_core9 = require("@signalwire/core");
var noop = () => {
};
var EXTERNAL_MEMBER_LIST_UPDATED_EVENT = "memberList.updated";
var INTERNAL_MEMBER_LIST_UPDATED_EVENT = (0, import_core9.toInternalEventName)({
  event: EXTERNAL_MEMBER_LIST_UPDATED_EVENT
});
var SYNTHETIC_MEMBER_LIST_UPDATED_EVENT = (0, import_core9.toSyntheticEvent)(
  INTERNAL_MEMBER_LIST_UPDATED_EVENT
);
var MEMBER_LIST_EVENTS = [
  /** Alias to `video.room.subscribed` */
  "video.room.joined",
  "video.member.joined",
  "video.member.left",
  "video.member.updated"
];
var isMemberListEvent = (event) => {
  return MEMBER_LIST_EVENTS.includes(event);
};
var getMemberListEventsToSubscribe = (subscriptions) => {
  return (0, import_core9.validateEventsToSubscribe)(MEMBER_LIST_EVENTS).filter((event) => {
    return !subscriptions.includes(event);
  });
};
var shouldHandleMemberList = (subscriptions) => {
  return subscriptions.some(
    (event) => event.includes(EXTERNAL_MEMBER_LIST_UPDATED_EVENT)
  );
};
var getMembersFromAction = (action) => {
  if (action.type === "video.room.joined") {
    return action.payload.room_session.members;
  }
  return [action.payload.member];
};
var getUpdatedMembers = ({
  action,
  memberList
}) => {
  const actionMembers = getMembersFromAction(action);
  switch (action.type) {
    case "video.member.left":
      actionMembers.forEach((member) => {
        memberList.delete(member.id);
      });
      break;
    default:
      actionMembers.forEach((member) => {
        memberList.set(member.id, member);
      });
  }
  return Array.from(memberList.values());
};
var initMemberListSubscriptions = (room, subscriptions) => {
  const events = getMemberListEventsToSubscribe(subscriptions);
  events.forEach((event) => {
    room.once(event, noop);
  });
  const eventBridgeHandler = ({ members }) => {
    room.emit(EXTERNAL_MEMBER_LIST_UPDATED_EVENT, { members });
  };
  room.on(SYNTHETIC_MEMBER_LIST_UPDATED_EVENT, eventBridgeHandler);
  const cleanup = () => {
    room.off(SYNTHETIC_MEMBER_LIST_UPDATED_EVENT, eventBridgeHandler);
  };
  return {
    cleanup
  };
};
function* membersListUpdatedWatcher({
  swEventChannel,
  instance
}) {
  const memberList = /* @__PURE__ */ new Map();
  function* worker(pubSubAction) {
    const roomSessionId = pubSubAction.type === "video.room.joined" ? pubSubAction.payload.room_session.id : pubSubAction.payload.room_session_id;
    const members = getUpdatedMembers({ action: pubSubAction, memberList });
    const memberListPayload = {
      /**
       * At this point it's needed to send the
       * `room_session_id` so the pubSubSaga can properly
       * infer the namespace for emitting the events to the
       * appropiate room.
       */
      room_session_id: roomSessionId,
      members
    };
    instance.emit(SYNTHETIC_MEMBER_LIST_UPDATED_EVENT, memberListPayload);
  }
  while (true) {
    const pubSubAction = yield import_core9.sagaEffects.take(
      swEventChannel,
      ({ type }) => {
        return isMemberListEvent(type);
      }
    );
    yield import_core9.sagaEffects.fork(worker, pubSubAction);
  }
}
var memberListUpdatedWorker = function* membersChangedWorker({
  channels: { swEventChannel },
  instance
}) {
  const subscriptions = instance.getSubscriptions();
  if (!shouldHandleMemberList(subscriptions)) {
    return;
  }
  const { cleanup } = initMemberListSubscriptions(instance, subscriptions);
  yield import_core9.sagaEffects.fork(membersListUpdatedWatcher, {
    swEventChannel,
    instance
  });
  instance.once("destroy", () => {
    cleanup();
  });
};

// src/video/workers/childMemberJoinedWorker.ts
var import_core10 = require("@signalwire/core");
var childMemberJoinedWorker = function* (options) {
  (0, import_core10.getLogger)().trace("childMemberJoinedWorker started");
  const { channels, instance, initialState, onDone, onFail } = options;
  const { swEventChannel } = channels;
  const { parentId } = initialState;
  if (!parentId) {
    throw new Error("Missing parentId for childMemberJoinedWorker");
  }
  const action = yield import_core10.sagaEffects.take(swEventChannel, (action2) => {
    if (action2.type === "video.member.joined") {
      return action2.payload.member.parent_id === parentId;
    }
    return false;
  });
  const { member } = action.payload;
  if (member == null ? void 0 : member.parent_id) {
    const byId = yield import_core10.sagaEffects.select(
      import_core10.componentSelectors.getComponentsById
    );
    const parent = Object.values(byId).find((row) => {
      return "memberId" in row && row.memberId === member.parent_id;
    });
    if (parent) {
      yield import_core10.sagaEffects.put(
        import_core10.componentActions.upsert({
          id: instance.callId,
          roomId: action.payload.room_id,
          roomSessionId: action.payload.room_session_id,
          memberId: member.id
        })
      );
      onDone == null ? void 0 : onDone();
    } else {
      onFail == null ? void 0 : onFail({ error: new Error("Unknown parent_id") });
    }
  }
  (0, import_core10.getLogger)().trace("childMemberJoinedWorker ended");
};

// src/video/workers/videoWorker.ts
var import_core14 = require("@signalwire/core");

// src/video/workers/videoStreamWorker.ts
var import_core11 = require("@signalwire/core");
var videoStreamWorker = function* (options) {
  (0, import_core11.getLogger)().trace("videoStreamWorker started");
  const {
    instance: roomSession,
    action: { type, payload },
    instanceMap: { get, set, remove }
  } = options;
  let streamInstance = get(payload.stream.id);
  if (!streamInstance) {
    streamInstance = import_core11.Rooms.createRoomSessionStreamObject({
      store: roomSession.store,
      payload
    });
  } else {
    streamInstance.setPayload(payload);
  }
  set(payload.stream.id, streamInstance);
  switch (type) {
    case "video.stream.started":
      roomSession.emit("stream.started", streamInstance);
      break;
    case "video.stream.ended":
      roomSession.emit("stream.ended", streamInstance);
      remove(payload.stream.id);
      break;
    default:
      (0, import_core11.getLogger)().warn(`Unknown video.stream event: "${type}"`);
      break;
  }
  (0, import_core11.getLogger)().trace("videoStreamWorker ended");
};

// src/video/workers/videoRecordWorker.ts
var import_core12 = require("@signalwire/core");
var videoRecordWorker = function* (options) {
  (0, import_core12.getLogger)().trace("videoRecordWorker started");
  const {
    instance: roomSession,
    action: { type, payload },
    instanceMap: { get, set, remove }
  } = options;
  let recordingInstance = get(payload.recording.id);
  if (!recordingInstance) {
    recordingInstance = import_core12.Rooms.createRoomSessionRecordingObject({
      store: roomSession.store,
      payload
    });
  } else {
    recordingInstance.setPayload(payload);
  }
  set(payload.recording.id, recordingInstance);
  const event = (0, import_core12.stripNamespacePrefix)(type);
  switch (type) {
    case "video.recording.started":
    case "video.recording.updated": {
      roomSession.emit(event, recordingInstance);
      break;
    }
    case "video.recording.ended":
      roomSession.emit(event, recordingInstance);
      remove(payload.recording.id);
      break;
    default:
      (0, import_core12.getLogger)().warn(`Unknown video.stream event: "${type}"`);
      break;
  }
  (0, import_core12.getLogger)().trace("videoRecordWorker ended");
};

// src/video/workers/videoPlaybackWorker.ts
var import_core13 = require("@signalwire/core");
var videoPlaybackWorker = function* (options) {
  (0, import_core13.getLogger)().trace("videoPlaybackWorker started");
  const {
    instance: roomSession,
    action: { type, payload },
    instanceMap: { get, set, remove }
  } = options;
  let playbackInstance = get(payload.playback.id);
  if (!playbackInstance) {
    playbackInstance = import_core13.Rooms.createRoomSessionPlaybackObject({
      store: roomSession.store,
      payload
    });
  } else {
    playbackInstance.setPayload(payload);
  }
  set(payload.playback.id, playbackInstance);
  const event = (0, import_core13.stripNamespacePrefix)(type);
  switch (type) {
    case "video.playback.started":
    case "video.playback.updated": {
      roomSession.emit(event, playbackInstance);
      break;
    }
    case "video.playback.ended":
      roomSession.emit(event, playbackInstance);
      remove(payload.playback.id);
      break;
    default:
      (0, import_core13.getLogger)().warn(`Unknown video.stream event: "${type}"`);
      break;
  }
  (0, import_core13.getLogger)().trace("videoPlaybackWorker ended");
};

// src/video/workers/videoWorker.ts
var videoWorker = function* (options) {
  (0, import_core14.getLogger)().trace("videoWorker started");
  const { channels, instance: roomSession } = options;
  const { swEventChannel } = channels;
  function* worker(action) {
    const { type, payload } = action;
    switch (type) {
      case "video.room.subscribed":
        yield import_core14.sagaEffects.fork(import_core14.MemberPosition.memberPositionWorker, __spreadProps(__spreadValues({}, options), {
          instance: roomSession,
          initialState: payload
        }));
        return;
      case "video.playback.started":
      case "video.playback.updated":
      case "video.playback.ended":
        yield import_core14.sagaEffects.fork(videoPlaybackWorker, __spreadValues({
          action
        }, options));
        return;
      // Return since we don't need to handle the raw event for this
      case "video.recording.started":
      case "video.recording.updated":
      case "video.recording.ended":
        yield import_core14.sagaEffects.fork(videoRecordWorker, __spreadValues({
          action
        }, options));
        return;
      case "video.stream.ended":
      case "video.stream.started":
        yield import_core14.sagaEffects.fork(videoStreamWorker, __spreadValues({
          action
        }, options));
        return;
      case "video.room.audience_count": {
        roomSession.emit("room.audienceCount", payload);
        return;
      }
      case "video.member.talking": {
        const { member } = payload;
        if ("talking" in member) {
          const suffix = member.talking ? "started" : "ended";
          roomSession.emit(`member.talking.${suffix}`, payload);
          const deprecatedSuffix = member.talking ? "start" : "stop";
          roomSession.emit(`member.talking.${deprecatedSuffix}`, payload);
        }
        break;
      }
      case "video.layout.changed": {
        roomSession.currentLayoutEvent = action.payload;
        break;
      }
      default:
        break;
    }
    const event = (0, import_core14.stripNamespacePrefix)(type, "video");
    roomSession.emit(event, payload);
  }
  const isVideoEvent = (action) => {
    return action.type.startsWith("video.");
  };
  while (true) {
    const action = yield import_core14.sagaEffects.take(
      swEventChannel,
      isVideoEvent
    );
    yield import_core14.sagaEffects.fork(worker, action);
  }
  (0, import_core14.getLogger)().trace("videoWorker ended");
};

// src/BaseRoomSession.ts
var BaseRoomSessionConnection = class _BaseRoomSessionConnection extends import_webrtc3.BaseConnection {
  constructor() {
    super(...arguments);
    __publicField(this, "_screenShareList", /* @__PURE__ */ new Set());
    __publicField(this, "_audioEl");
    __publicField(this, "_overlayMap");
    __publicField(this, "_localVideoOverlay");
  }
  get audioEl() {
    return this._audioEl;
  }
  set overlayMap(map) {
    this._overlayMap = map;
  }
  get overlayMap() {
    return this._overlayMap;
  }
  set localVideoOverlay(overlay) {
    this._localVideoOverlay = overlay;
  }
  get localVideoOverlay() {
    return this._localVideoOverlay;
  }
  get screenShareList() {
    return Array.from(this._screenShareList);
  }
  _attachSpeakerTrackListener() {
    if (!(0, import_webrtc3.supportsMediaOutput)()) return;
    (0, import_webrtc3.createSpeakerDeviceWatcher)().then((deviceWatcher) => {
      deviceWatcher.on("removed", (data) => __async(this, null, function* () {
        var _a, _b;
        const sinkId = this._audioEl.sinkId;
        const disconnectedSpeaker = data.changes.find((device) => {
          const payloadDeviceId = device.payload.deviceId;
          return payloadDeviceId === sinkId || payloadDeviceId === "" && sinkId === "default" || payloadDeviceId === "default" && sinkId === "";
        });
        if (disconnectedSpeaker) {
          this.emit("speaker.disconnected", {
            deviceId: disconnectedSpeaker.payload.deviceId,
            label: disconnectedSpeaker.payload.label
          });
          yield (_b = (_a = this._audioEl).setSinkId) == null ? void 0 : _b.call(_a, "");
          const defaultSpeakers = yield (0, import_webrtc3.getSpeakerById)("default");
          if (!(defaultSpeakers == null ? void 0 : defaultSpeakers.deviceId)) return;
          this.emit("speaker.updated", {
            previous: {
              deviceId: disconnectedSpeaker.payload.deviceId,
              label: disconnectedSpeaker.payload.label
            },
            current: {
              deviceId: defaultSpeakers.deviceId,
              label: defaultSpeakers.label
            }
          });
        }
      }));
    });
  }
  /** @internal */
  _finalize() {
    this._screenShareList.clear();
    super._finalize();
  }
  /** @internal */
  hangup(id) {
    return __async(this, null, function* () {
      this._screenShareList.forEach((screenShare) => {
        screenShare.leave();
      });
      return __superGet(_BaseRoomSessionConnection.prototype, this, "hangup").call(this, id);
    });
  }
  leave() {
    return this.hangup();
  }
  /**
   * This method will be called by `join()` right before the
   * `connect()` happens and it's a way for us to control
   * exactly when the workers are attached.
   * @internal
   */
  attachPreConnectWorkers() {
    this.runWorker("memberListUpdated", {
      worker: memberListUpdatedWorker
    });
  }
  /** @internal */
  getAudioEl() {
    if (this._audioEl) return this._audioEl;
    this._audioEl = new Audio();
    this._attachSpeakerTrackListener();
    return this._audioEl;
  }
  getMemberOverlay(memberId) {
    return this.overlayMap.get(addOverlayPrefix(memberId));
  }
  /**
   * Allow sharing the screen within the room.
   */
  startScreenShare() {
    return __async(this, arguments, function* (opts = {}) {
      return new Promise((resolve, reject) => __async(this, null, function* () {
        var _a;
        const {
          autoJoin = true,
          audio = false,
          video = true,
          layout,
          positions
        } = opts;
        try {
          const displayStream = yield (0, import_webrtc3.getDisplayMedia)({
            audio: audio === true ? SCREENSHARE_AUDIO_CONSTRAINTS : audio,
            video
          });
          const options = __spreadProps(__spreadValues({}, this.options), {
            screenShare: true,
            recoverCall: false,
            localStream: displayStream,
            remoteStream: void 0,
            userVariables: __spreadProps(__spreadValues({}, ((_a = this.options) == null ? void 0 : _a.userVariables) || {}), {
              memberCallId: this.callId,
              memberId: this.memberId
            }),
            layout,
            positions
          });
          const screenShare = (0, import_core15.connect)({
            store: this.store,
            Component: RoomSessionScreenShareAPI
          })(options);
          displayStream.getVideoTracks().forEach((t) => {
            t.addEventListener("ended", () => {
              if (screenShare && screenShare.active) {
                screenShare.leave();
              }
            });
          });
          screenShare.once("destroy", () => {
            screenShare.emit("room.left");
            this._screenShareList.delete(screenShare);
          });
          screenShare.runWorker("childMemberJoinedWorker", {
            worker: childMemberJoinedWorker,
            onDone: () => resolve(screenShare),
            onFail: reject,
            initialState: {
              parentId: this.memberId
            }
          });
          this._screenShareList.add(screenShare);
          if (autoJoin) {
            return yield screenShare.join();
          }
          return resolve(screenShare);
        } catch (error) {
          this.logger.error("ScreenShare Error", error);
          reject(error);
        }
      }));
    });
  }
  updateSpeaker({ deviceId }) {
    const prevId = this.audioEl.sinkId;
    this.once(
      // @ts-expect-error
      `${import_core15.LOCAL_EVENT_PREFIX}.speaker.updated`,
      (newId) => __async(this, null, function* () {
        const prevSpeaker = yield (0, import_webrtc3.getSpeakerById)(prevId);
        const newSpeaker = yield (0, import_webrtc3.getSpeakerById)(newId);
        const isSame = (newSpeaker == null ? void 0 : newSpeaker.deviceId) === (prevSpeaker == null ? void 0 : prevSpeaker.deviceId);
        if (!(newSpeaker == null ? void 0 : newSpeaker.deviceId) || isSame) return;
        this.emit("speaker.updated", {
          previous: {
            deviceId: prevSpeaker == null ? void 0 : prevSpeaker.deviceId,
            label: prevSpeaker == null ? void 0 : prevSpeaker.label
          },
          current: {
            deviceId: newSpeaker.deviceId,
            label: newSpeaker.label
          }
        });
      })
    );
    return this.triggerCustomSaga(audioSetSpeakerAction(deviceId));
  }
};

// src/RoomSessionDevice.ts
var import_core16 = require("@signalwire/core");
var import_webrtc4 = require("@signalwire/webrtc");
var RoomSessionDeviceConnection = class extends import_webrtc4.BaseConnection {
  join() {
    return super.invite();
  }
  leave() {
    return super.hangup();
  }
};
var RoomSessionDeviceAPI = (0, import_core16.extendComponent)(RoomSessionDeviceConnection, {
  audioMute: import_core16.Rooms.audioMuteMember,
  audioUnmute: import_core16.Rooms.audioUnmuteMember,
  videoMute: import_core16.Rooms.videoMuteMember,
  videoUnmute: import_core16.Rooms.videoUnmuteMember,
  setInputVolume: import_core16.Rooms.setInputVolumeMember,
  setMicrophoneVolume: import_core16.Rooms.setInputVolumeMember,
  setInputSensitivity: import_core16.Rooms.setInputSensitivityMember
});

// src/video/VideoRoomSession.ts
var VideoRoomSessionConnection = class _VideoRoomSessionConnection extends BaseRoomSessionConnection {
  constructor(options) {
    super(options);
    __publicField(this, "_deviceList", /* @__PURE__ */ new Set());
    __publicField(this, "_currentLayoutEvent");
    this.initWorker();
  }
  set currentLayoutEvent(event) {
    this._currentLayoutEvent = event;
  }
  get currentLayoutEvent() {
    return this._currentLayoutEvent;
  }
  get currentLayout() {
    var _a;
    return (_a = this._currentLayoutEvent) == null ? void 0 : _a.layout;
  }
  get currentPosition() {
    var _a, _b;
    return (_b = (_a = this._currentLayoutEvent) == null ? void 0 : _a.layout.layers.find(
      (layer) => layer.member_id === this.memberId
    )) == null ? void 0 : _b.position;
  }
  get deviceList() {
    return Array.from(this._deviceList);
  }
  get interactivityMode() {
    return this.select(({ session }) => {
      var _a;
      const { authState } = session;
      return (_a = authState == null ? void 0 : authState.join_as) != null ? _a : "";
    });
  }
  get permissions() {
    return this.select(({ session }) => {
      var _a, _b;
      const { authState } = session;
      return (_b = (_a = authState == null ? void 0 : authState.room) == null ? void 0 : _a.scopes) != null ? _b : [];
    });
  }
  initWorker() {
    this.runWorker("videoWorker", {
      worker: videoWorker
    });
  }
  /** @internal */
  getSubscriptions() {
    const eventNamesWithPrefix = this.eventNames().map((event) => {
      return `video.${String(event)}`;
    });
    return (0, import_core17.validateEventsToSubscribe)(
      eventNamesWithPrefix
    );
  }
  /** @internal */
  _finalize() {
    this._deviceList.clear();
    super._finalize();
  }
  /** @internal */
  hangup(id) {
    return __async(this, null, function* () {
      this._deviceList.forEach((device) => {
        device.leave();
      });
      return __superGet(_VideoRoomSessionConnection.prototype, this, "hangup").call(this, id);
    });
  }
  join() {
    return super.invite();
  }
  /**
   * @deprecated Use {@link getLayouts} instead. `getLayoutList` will
   * be removed in v3.0.0
   */
  getLayoutList() {
    return this.getLayouts();
  }
  /**
   * @deprecated Use {@link getMembers} instead. `getMemberList` will
   * be removed in v3.0.0
   */
  getMemberList() {
    return this.getMembers();
  }
  /** @deprecated Use {@link startScreenShare} instead. */
  createScreenShareObject() {
    return __async(this, arguments, function* (opts = {}) {
      return this.startScreenShare(opts);
    });
  }
  /**
   * Allow to add a camera to the room.
   */
  addCamera(opts = {}) {
    const _a = opts, { autoJoin = true } = _a, video = __objRest(_a, ["autoJoin"]);
    return this.addDevice({
      autoJoin,
      video
    });
  }
  /**
   * Allow to add a microphone to the room.
   */
  addMicrophone(opts = {}) {
    const _a = opts, { autoJoin = true } = _a, audio = __objRest(_a, ["autoJoin"]);
    return this.addDevice({
      autoJoin,
      audio
    });
  }
  /**
   * Allow to add additional devices to the room like cameras or microphones.
   */
  addDevice() {
    return __async(this, arguments, function* (opts = {}) {
      return new Promise((resolve, reject) => __async(this, null, function* () {
        var _a;
        const { autoJoin = true, audio = false, video = false } = opts;
        if (!audio && !video) {
          throw new TypeError(
            "At least one of `audio` or `video` must be requested."
          );
        }
        const options = __spreadProps(__spreadValues({}, this.options), {
          localStream: void 0,
          remoteStream: void 0,
          audio,
          video,
          additionalDevice: true,
          recoverCall: false,
          userVariables: __spreadProps(__spreadValues({}, ((_a = this.options) == null ? void 0 : _a.userVariables) || {}), {
            memberCallId: this.callId,
            memberId: this.memberId
          })
        });
        const roomDevice = (0, import_core17.connect)({
          store: this.store,
          Component: RoomSessionDeviceAPI
        })(options);
        roomDevice.once("destroy", () => {
          roomDevice.emit("room.left");
          this._deviceList.delete(roomDevice);
        });
        try {
          roomDevice.runWorker("childMemberJoinedWorker", {
            worker: childMemberJoinedWorker,
            onDone: () => resolve(roomDevice),
            onFail: reject,
            initialState: {
              parentId: this.memberId
            }
          });
          this._deviceList.add(roomDevice);
          if (autoJoin) {
            return yield roomDevice.join();
          }
          return resolve(roomDevice);
        } catch (error) {
          this.logger.error("RoomDevice Error", error);
          reject(error);
        }
      }));
    });
  }
};
var VideoRoomSessionAPI = (0, import_core17.extendComponent)(VideoRoomSessionConnection, {
  audioMute: import_core17.Rooms.audioMuteMember,
  audioUnmute: import_core17.Rooms.audioUnmuteMember,
  videoMute: import_core17.Rooms.videoMuteMember,
  videoUnmute: import_core17.Rooms.videoUnmuteMember,
  deaf: import_core17.Rooms.deafMember,
  undeaf: import_core17.Rooms.undeafMember,
  setInputVolume: import_core17.Rooms.setInputVolumeMember,
  setOutputVolume: import_core17.Rooms.setOutputVolumeMember,
  setMicrophoneVolume: import_core17.Rooms.setInputVolumeMember,
  setSpeakerVolume: import_core17.Rooms.setOutputVolumeMember,
  setInputSensitivity: import_core17.Rooms.setInputSensitivityMember,
  removeMember: import_core17.Rooms.removeMember,
  removeAllMembers: import_core17.Rooms.removeAllMembers,
  getMembers: import_core17.Rooms.getMembers,
  getLayouts: import_core17.Rooms.getLayouts,
  setLayout: import_core17.Rooms.setLayout,
  setPositions: import_core17.Rooms.setPositions,
  setMemberPosition: import_core17.Rooms.setMemberPosition,
  hideVideoMuted: import_core17.Rooms.hideVideoMuted,
  showVideoMuted: import_core17.Rooms.showVideoMuted,
  getRecordings: import_core17.Rooms.getRecordings,
  startRecording: import_core17.Rooms.startRecording,
  getPlaybacks: import_core17.Rooms.getPlaybacks,
  play: import_core17.Rooms.play,
  setHideVideoMuted: import_core17.Rooms.setHideVideoMuted,
  getMeta: import_core17.Rooms.getMeta,
  setMeta: import_core17.Rooms.setMeta,
  updateMeta: import_core17.Rooms.updateMeta,
  deleteMeta: import_core17.Rooms.deleteMeta,
  getMemberMeta: import_core17.Rooms.getMemberMeta,
  setMemberMeta: import_core17.Rooms.setMemberMeta,
  updateMemberMeta: import_core17.Rooms.updateMemberMeta,
  deleteMemberMeta: import_core17.Rooms.deleteMemberMeta,
  promote: import_core17.Rooms.promote,
  demote: import_core17.Rooms.demote,
  getStreams: import_core17.Rooms.getStreams,
  startStream: import_core17.Rooms.startStream,
  lock: import_core17.Rooms.lock,
  unlock: import_core17.Rooms.unlock,
  setRaisedHand: import_core17.Rooms.setRaisedHand,
  setPrioritizeHandraise: import_core17.Rooms.setPrioritizeHandraise
});
var isVideoRoomSession = (room) => {
  return room instanceof VideoRoomSessionConnection;
};
var createVideoRoomSessionObject = (params) => {
  const room = (0, import_core17.connect)({
    store: params.store,
    customSagas: params.customSagas,
    Component: VideoRoomSessionAPI
  })(params);
  return room;
};

// src/fabric/FabricRoomSession.ts
var import_core27 = require("@signalwire/core");

// src/utils/storage.ts
var import_jwt_decode = __toESM(require("jwt-decode"));
var import_core18 = require("@signalwire/core");
var getStorage = () => {
  if (window && window.sessionStorage) {
    return window.sessionStorage;
  }
  return void 0;
};
var sessionStorageManager = (token) => {
  var _a;
  let roomName = "";
  try {
    const jwtPayload = (0, import_jwt_decode.default)(token);
    roomName = (_a = jwtPayload == null ? void 0 : jwtPayload.r) != null ? _a : "";
  } catch (e) {
    try {
      const jwtPayload = (0, import_jwt_decode.default)(token, { header: true });
      roomName = jwtPayload.typ || "";
    } catch (e2) {
      if (process.env.NODE_ENV !== "production") {
        (0, import_core18.getLogger)().error("[sessionStorageManager] error decoding JWT", token);
      }
      roomName = "";
    }
  }
  const valid = Boolean(roomName);
  return {
    authStateKey: valid && `as-${roomName}`,
    protocolKey: valid && `pt-${roomName}`,
    callIdKey: valid && `ci-${roomName}`
  };
};

// src/fabric/utils/constants.ts
var PREVIOUS_CALLID_STORAGE_KEY = "ci-SAT";

// src/fabric/workers/wsClientWorker.ts
var import_core19 = require("@signalwire/core");
var wsClientWorker = function* (options) {
  (0, import_core19.getLogger)().debug("wsClientWorker started");
  const { channels, initialState, instance: client } = options;
  const { swEventChannel } = channels;
  const { handleIncomingInvite } = initialState;
  function* fireHoseWorker(action) {
    client.emit(action.type, action.payload);
  }
  function* vertoInviteWorker(action) {
    handleIncomingInvite(action.payload.params);
  }
  const isVertoInvite = (action) => {
    if (action.type === "webrtc.message") {
      return action.payload.method === "verto.invite";
    }
    return false;
  };
  try {
    while (true) {
      const action = yield import_core19.sagaEffects.take(
        swEventChannel,
        () => true
      );
      yield import_core19.sagaEffects.fork(fireHoseWorker, action);
      if (isVertoInvite(action)) {
        (0, import_core19.getLogger)().debug("Receiving a call over WebSocket", action);
        yield import_core19.sagaEffects.fork(
          vertoInviteWorker,
          action
        );
      }
    }
  } finally {
    (0, import_core19.getLogger)().trace("wsClientWorker ended");
  }
};

// src/fabric/workers/conversationWorker.ts
var import_core20 = require("@signalwire/core");
var conversationWorker = function* (options) {
  (0, import_core20.getLogger)().debug("conversationWorker started");
  const {
    channels: { swEventChannel },
    initialState
  } = options;
  const { conversation } = initialState;
  const isConversationEvent = (action) => {
    return action.type.startsWith("conversation.");
  };
  while (true) {
    const action = yield import_core20.sagaEffects.take(
      swEventChannel,
      isConversationEvent
    );
    conversation.handleEvent(action.payload);
  }
  (0, import_core20.getLogger)().trace("conversationWorker ended");
};

// src/fabric/workers/fabricWorker.ts
var import_core26 = require("@signalwire/core");

// src/fabric/FabricRoomSessionMember.ts
var import_core21 = require("@signalwire/core");
var FabricRoomSessionMemberAPI = class extends import_core21.BaseComponent {
  constructor(options) {
    super(options);
    __publicField(this, "_payload");
    this._payload = options.payload;
  }
  get id() {
    return this._payload.member.member_id;
  }
  get callId() {
    return this._payload.member.call_id;
  }
  get nodeId() {
    return this._payload.member.node_id;
  }
  get memberId() {
    return this.id;
  }
  get roomSessionId() {
    return this._payload.room_session_id;
  }
  get roomId() {
    return this._payload.room_id;
  }
  get parentId() {
    return this._payload.member.parent_id;
  }
  get name() {
    return this._payload.member.name;
  }
  get type() {
    return this._payload.member.type;
  }
  get requestedPosition() {
    return this._payload.member.requested_position;
  }
  get currentPosition() {
    return this._payload.member.current_position;
  }
  get meta() {
    return this._payload.member.meta;
  }
  get handraised() {
    return this._payload.member.handraised;
  }
  get talking() {
    return this._payload.member.talking;
  }
  get audioMuted() {
    return this._payload.member.audio_muted;
  }
  get videoMuted() {
    return this._payload.member.video_muted;
  }
  get deaf() {
    return this._payload.member.deaf;
  }
  get visible() {
    return this._payload.member.visible;
  }
  get inputVolume() {
    return this._payload.member.input_volume;
  }
  get outputVolume() {
    return this._payload.member.output_volume;
  }
  get inputSensitivity() {
    return this._payload.member.input_sensitivity;
  }
  get subscriberData() {
    return this._payload.member.subscriber_data;
  }
  /** @internal */
  setPayload(payload) {
    const newPayload = __spreadProps(__spreadValues(__spreadValues({}, this._payload), payload), {
      member: __spreadValues(__spreadValues({}, this._payload.member), payload.member)
    });
    this._payload = newPayload;
  }
};
var createFabricRoomSessionMemberObject = (params) => {
  const member = (0, import_core21.connect)({
    store: params.store,
    Component: FabricRoomSessionMemberAPI
  })(params);
  return member;
};

// src/fabric/workers/callSegmentWorker.ts
var import_core25 = require("@signalwire/core");

// src/fabric/workers/callLeftWorker.ts
var import_core22 = require("@signalwire/core");
var callLeftWorker = function* (options) {
  (0, import_core22.getLogger)().trace("callLeftWorker started");
  const {
    action: { payload },
    instance: cfRoomSession,
    instanceMap
  } = options;
  const { room_session_id } = payload;
  instanceMap.getAll().forEach(([key, obj]) => {
    if (obj instanceof FabricRoomSessionMemberAPI && obj.roomSessionId === room_session_id) {
      instanceMap.remove(key);
    }
  });
  cfRoomSession.emit("call.left", payload);
  cfRoomSession.emit("room.left", payload);
  (0, import_core22.getLogger)().trace("callLeftWorker ended");
};

// src/fabric/workers/callJoinWorker.ts
var import_core24 = require("@signalwire/core");

// src/fabric/workers/fabricMemberWorker.ts
var import_core23 = require("@signalwire/core");
var fabricMemberWorker = function* (options) {
  (0, import_core23.getLogger)().trace("fabricMemberWorker started");
  const {
    instance: roomSession,
    action: { type, payload },
    instanceMap: { get, set, remove }
  } = options;
  const memberId = payload.member.member_id;
  let memberInstance = get(memberId);
  if (!memberInstance && type !== "member.talking") {
    memberInstance = createFabricRoomSessionMemberObject({
      store: roomSession.store,
      payload
    });
  }
  if (memberInstance) {
    memberInstance.setPayload(payload);
  }
  set(memberId, memberInstance);
  if (type.startsWith("member.updated.")) {
    const clientType = (0, import_core23.fromSnakeToCamelCase)(type);
    roomSession.emit(clientType, payload);
  }
  switch (type) {
    case "member.joined":
      roomSession.emit(type, payload);
      break;
    case "member.updated":
      roomSession.emit(type, payload);
      break;
    case "member.left":
      roomSession.emit(type, payload);
      remove(memberId);
      break;
    case "member.talking":
      roomSession.emit(type, payload);
      break;
    default:
      break;
  }
  (0, import_core23.getLogger)().trace("fabricMemberWorker ended");
};

// src/fabric/utils/helpers.ts
var mapInternalFabricMemberToInternalVideoMemberEntity = (params) => {
  return {
    id: params.member_id,
    room_id: params.room_id,
    room_session_id: params.room_session_id,
    name: params.name,
    type: params.type,
    handraised: params.handraised,
    visible: params.visible,
    audio_muted: params.audio_muted,
    video_muted: params.video_muted,
    deaf: params.deaf,
    input_volume: params.input_volume,
    output_volume: params.output_volume,
    input_sensitivity: params.input_sensitivity,
    meta: params.meta,
    talking: params.talking,
    current_position: params.current_position,
    requested_position: params.requested_position,
    parent_id: params.parent_id
  };
};
var mapInternalFabricMemberToInternalVideoMemberUpdatedEntity = (params) => {
  return __spreadProps(__spreadValues({}, mapInternalFabricMemberToInternalVideoMemberEntity(params)), {
    updated: params.updated.map(
      (key) => key === "member_id" ? "id" : key
    )
  });
};
var mapInternalFabricRoomToInternalVideoRoomEntity = (params) => {
  return {
    room_id: params.room_id,
    room_session_id: params.room_session_id,
    event_channel: params.event_channel,
    name: params.name,
    recording: params.recording,
    hide_video_muted: params.hide_video_muted,
    preview_url: params.preview_url,
    recordings: params.recordings,
    playbacks: params.playbacks,
    streams: params.streams,
    prioritize_handraise: params.prioritize_handraise
  };
};
var mapInternalFabricRoomToInternalVideoRoomSessionEntity = (params) => {
  return {
    id: params.id,
    display_name: params.display_name,
    room_id: params.room_id,
    room_session_id: params.room_session_id,
    event_channel: params.event_channel,
    name: params.name,
    recording: params.recording,
    recordings: params.recordings,
    playbacks: params.playbacks,
    hide_video_muted: params.hide_video_muted,
    preview_url: params.preview_url,
    layout_name: params.layout_name,
    locked: params.locked,
    meta: params.meta,
    members: params.members.map(
      mapInternalFabricMemberToInternalVideoMemberEntity
    ),
    streaming: params.streaming,
    streams: params.streams,
    prioritize_handraise: params.prioritize_handraise,
    updated: params.updated
  };
};
var mapCallJoinedToRoomSubscribedEventParams = (params) => {
  return {
    call_id: params.call_id,
    member_id: params.member_id,
    room: __spreadProps(__spreadValues({}, mapInternalFabricRoomToInternalVideoRoomEntity(params.room_session)), {
      members: params.room_session.members.map(
        mapInternalFabricMemberToInternalVideoMemberEntity
      )
    }),
    room_session: __spreadProps(__spreadValues({}, mapInternalFabricRoomToInternalVideoRoomSessionEntity(
      params.room_session
    )), {
      members: params.room_session.members.map(
        mapInternalFabricMemberToInternalVideoMemberEntity
      )
    })
  };
};
var mapFabricMemberToVideoMemberJoinAndLeftEventParams = (params) => {
  return {
    room_session_id: params.room_session_id,
    room_id: params.room_id,
    member: mapInternalFabricMemberToInternalVideoMemberEntity(params.member)
  };
};
var mapFabricMemberActionToVideoMemberJoinAndLeftAction = (action) => {
  return {
    type: `video.${action.type}`,
    payload: mapFabricMemberToVideoMemberJoinAndLeftEventParams(action.payload)
  };
};
var mapFabricMemberEventToVideoMemberUpdatedEventParams = (params) => {
  return {
    room_session_id: params.room_session_id,
    room_id: params.room_id,
    member: mapInternalFabricMemberToInternalVideoMemberUpdatedEntity(
      params.member
    )
  };
};
var mapFabricMemberActionToVideoMemberUpdatedAction = (action) => {
  return {
    type: `video.${action.type}`,
    payload: mapFabricMemberEventToVideoMemberUpdatedEventParams(
      action.payload
    )
  };
};
var mapFabricLayoutActionToVideoLayoutAction = (action) => {
  return {
    type: `video.${action.type}`,
    payload: action.payload
  };
};

// src/fabric/utils/capabilitiesHelpers.ts
var CapabilityOnOffState = class {
  constructor(_flags) {
    this._flags = _flags;
  }
  get on() {
    return this._flags.some((flag) => !flag.endsWith(".off"));
  }
  get off() {
    return this._flags.some((flag) => !flag.endsWith(".on"));
  }
};
var MemberCapability = class {
  constructor(_flags, _memberType) {
    this._flags = _flags;
    this._memberType = _memberType;
    __publicField(this, "_muteAudio");
    __publicField(this, "_muteVideo");
    __publicField(this, "_deaf");
  }
  get muteAudio() {
    var _a;
    this._muteAudio = (_a = this._muteAudio) != null ? _a : new CapabilityOnOffState(
      this._flags.filter(
        (flag) => flag === this._memberType || flag === `${this._memberType}.mute` || flag.startsWith(`${this._memberType}.mute.audio`)
      )
    );
    return this._muteAudio;
  }
  get muteVideo() {
    var _a;
    this._muteVideo = (_a = this._muteVideo) != null ? _a : new CapabilityOnOffState(
      this._flags.filter(
        (flag) => flag === this._memberType || flag === `${this._memberType}.mute` || flag.startsWith(`${this._memberType}.mute.video`)
      )
    );
    return this._muteVideo;
  }
  get microphoneVolume() {
    return this._flags.some(
      (flag) => flag === this._memberType || flag === `${this._memberType}.microphone` || flag.startsWith(`${this._memberType}.microphone.volume`)
    );
  }
  get microphoneSensitivity() {
    return this._flags.some(
      (flag) => flag === this._memberType || flag === `${this._memberType}.microphone` || flag.startsWith(`${this._memberType}.microphone.sensitivity`)
    );
  }
  get speakerVolume() {
    return this._flags.some(
      (flag) => flag === this._memberType || flag === `${this._memberType}.speaker` || flag.startsWith(`${this._memberType}.speaker.volume`)
    );
  }
  get deaf() {
    var _a;
    this._deaf = (_a = this._deaf) != null ? _a : new CapabilityOnOffState(
      this._flags.filter(
        (flag) => flag === this._memberType || flag.startsWith(`${this._memberType}.deaf`)
      )
    );
    return this._deaf;
  }
  get raisehand() {
    return {
      on: true,
      off: true
    };
  }
  get position() {
    return this._flags.some(
      (flag) => flag === this._memberType || flag.startsWith(`${this._memberType}.position`)
    );
  }
  get meta() {
    return this._flags.some(
      (flag) => flag === this._memberType || flag.startsWith(`${this._memberType}.meta`)
    );
  }
  get remove() {
    return this._flags.some(
      (flag) => flag === this._memberType || flag.startsWith(`${this._memberType}.remove`)
    );
  }
};
var CallCapabilities = class {
  constructor(_flags) {
    this._flags = _flags;
    __publicField(this, "_self");
    __publicField(this, "_member");
    __publicField(this, "_vmutedHide");
    __publicField(this, "_lock");
  }
  _buildMemberCapability(memberType) {
    return new MemberCapability(
      this._flags.filter((flag) => flag.startsWith(memberType)),
      memberType
    );
  }
  get self() {
    var _a;
    this._self = (_a = this._self) != null ? _a : this._buildMemberCapability("self");
    return this._self;
  }
  get member() {
    var _a;
    this._member = (_a = this._member) != null ? _a : this._buildMemberCapability("member");
    return this._member;
  }
  get end() {
    return this._flags.some((capability) => capability === "end");
  }
  get setLayout() {
    return this._flags.some((capability) => capability.startsWith("layout"));
  }
  get sendDigit() {
    return this._flags.some((capability) => capability.startsWith("digit"));
  }
  get vmutedHide() {
    var _a;
    this._vmutedHide = (_a = this._vmutedHide) != null ? _a : new CapabilityOnOffState(
      this._flags.filter((flag) => flag.startsWith("vmuted"))
    );
    return this._vmutedHide;
  }
  get lock() {
    var _a;
    this._lock = (_a = this._lock) != null ? _a : new CapabilityOnOffState(
      this._flags.filter((flag) => flag.startsWith("lock"))
    );
    return this._lock;
  }
  get device() {
    return this._flags.some((capability) => capability === "device");
  }
  get screenshare() {
    return this._flags.some((capability) => capability === "screenshare");
  }
};
var mapCapabilityPayload = (capabilities) => new CallCapabilities(capabilities);

// src/fabric/workers/callJoinWorker.ts
var callJoinWorker = function* (options) {
  var _a;
  (0, import_core24.getLogger)().trace("callJoinWorker started");
  const { action, instanceMap, instance: cfRoomSession } = options;
  const { payload } = action;
  const { get, set } = instanceMap;
  yield import_core24.sagaEffects.fork(import_core24.MemberPosition.memberPositionWorker, __spreadProps(__spreadValues({}, options), {
    /**
     * The {@link memberPositionWorker} worker understands only the Video SDK events.
     * So, we need to map CF SDK event to Video SDK event.
     * Similar to what we do in the {@link callSegmentWorker}, for member events.
     */
    initialState: mapCallJoinedToRoomSubscribedEventParams(payload),
    dispatcher: function* (subType, subPayload) {
      const fabricType = (0, import_core24.stripNamespacePrefix)(subType, "video");
      const fabricPaylod = __spreadProps(__spreadValues({}, subPayload), {
        member: __spreadProps(__spreadValues({}, subPayload.member), {
          member_id: subPayload.member.id
        })
      });
      yield import_core24.sagaEffects.fork(fabricMemberWorker, __spreadProps(__spreadValues({}, options), {
        action: { type: fabricType, payload: fabricPaylod }
      }));
    }
  }));
  (_a = payload.room_session.members) == null ? void 0 : _a.forEach((member) => {
    let memberInstance = get(member.member_id);
    if (!memberInstance) {
      memberInstance = createFabricRoomSessionMemberObject({
        store: cfRoomSession.store,
        payload: {
          member,
          room_id: payload.room_id,
          room_session_id: payload.room_session_id
        }
      });
    } else {
      memberInstance.setPayload({
        member,
        room_id: payload.room_id,
        room_session_id: payload.room_session_id
      });
    }
    set(member.member_id, memberInstance);
  });
  cfRoomSession.member = get(payload.member_id);
  cfRoomSession.capabilities = mapCapabilityPayload(payload.capabilities);
  const fabricEvent = __spreadProps(__spreadValues({}, payload), {
    capabilities: cfRoomSession.capabilities
  });
  cfRoomSession.emit("call.joined", fabricEvent);
  (0, import_core24.getLogger)().trace("callJoinWorker ended");
};

// src/fabric/workers/callSegmentWorker.ts
var callSegmentWorker = function* (options) {
  const {
    action,
    channels: { swEventChannel },
    instance: cfRoomSession
  } = options;
  const segmentCallId = action.payload.call_id;
  const segmentRooSessionId = action.payload.room_session_id;
  (0, import_core25.getLogger)().debug(
    `callSegmentWorker started for: callId ${segmentCallId}, roomSessionId ${segmentRooSessionId}`
  );
  yield import_core25.sagaEffects.fork(callJoinWorker, __spreadProps(__spreadValues({}, options), {
    action
  }));
  function* worker(action2) {
    const { type, payload } = action2;
    switch (type) {
      case "call.joined":
        break;
      case "call.left":
        yield import_core25.sagaEffects.call(callLeftWorker, __spreadProps(__spreadValues({}, options), {
          action: action2
        }));
        return true;
      case "call.updated":
        cfRoomSession.emit(type, payload);
        cfRoomSession.emit("room.updated", payload);
        break;
      case "call.play":
        cfRoomSession.emit(type, payload);
        break;
      case "call.connect":
        cfRoomSession.emit(type, payload);
        break;
      case "call.room":
        cfRoomSession.emit(type, payload);
        break;
      /**
       * The Core module includes a generic worker, {@link memberPositionWorker},
       * which listens for member & layout events to add a "current_position" parameter
       * and handle member "updated" parameter.
       * This worker in CF SDK is initialized by the {@link callJoinWorker} worker.
       *
       * To ensure compatibility, we map these events to Video SDK events and
       * re-publish them on the channel so that they can be processed by the
       * generic worker. Note that the generic worker only dispatches "member.updated"
       * and "member.updated.*" events.
       *
       * Additionally, the "member.joined" event is monitored by another worker,
       * {@link childMemberJoinedWorker}, specifically for the screen share API.
       */
      case "member.joined":
      case "member.left": {
        yield import_core25.sagaEffects.fork(fabricMemberWorker, __spreadProps(__spreadValues({}, options), {
          action: action2
        }));
        const videoAction = mapFabricMemberActionToVideoMemberJoinAndLeftAction(action2);
        yield import_core25.sagaEffects.put(swEventChannel, videoAction);
        break;
      }
      case "member.updated": {
        const videoAction = mapFabricMemberActionToVideoMemberUpdatedAction(action2);
        yield import_core25.sagaEffects.put(swEventChannel, videoAction);
        break;
      }
      case "layout.changed": {
        cfRoomSession.currentLayoutEvent = action2.payload;
        cfRoomSession.emit(type, payload);
        const videoAction = mapFabricLayoutActionToVideoLayoutAction(action2);
        yield import_core25.sagaEffects.put(swEventChannel, videoAction);
        break;
      }
      case "member.talking": {
        yield import_core25.sagaEffects.fork(fabricMemberWorker, __spreadProps(__spreadValues({}, options), {
          action: action2
        }));
        break;
      }
      default: {
        (0, import_core25.getLogger)().warn("Got an unknown fabric event", action2);
      }
    }
    return false;
  }
  const isSegmentEvent = (action2) => {
    const { type, payload } = action2;
    const shouldWatch = type.startsWith("call.") || type.startsWith("member.") || type.startsWith("layout.");
    const hasSegmentCallId = "call_id" in payload && segmentCallId === payload.call_id;
    const hasSegmentRoomSessionId = segmentRooSessionId === payload.room_session_id;
    if (shouldWatch && (hasSegmentCallId || hasSegmentRoomSessionId)) {
      return true;
    }
    return false;
  };
  while (true) {
    const action2 = yield import_core25.sagaEffects.take(
      swEventChannel,
      isSegmentEvent
    );
    const task = yield import_core25.sagaEffects.fork(worker, action2);
    const shouldStop = yield import_core25.sagaEffects.join(task);
    if (shouldStop) return;
  }
};

// src/fabric/workers/fabricWorker.ts
var fabricWorker = function* (options) {
  (0, import_core26.getLogger)().trace("fabricWorker started");
  const {
    channels: { swEventChannel },
    instance: cfRoomSession
  } = options;
  function* worker(action) {
    const { type, payload } = action;
    switch (type) {
      case "call.joined": {
        if (!cfRoomSession.selfMember) {
          const memberInstance = createFabricRoomSessionMemberObject({
            store: cfRoomSession.store,
            payload: {
              member: action.payload.room_session.members.find(
                (m) => m.member_id === action.payload.member_id
              ),
              room_id: action.payload.room_id,
              room_session_id: action.payload.room_session_id
            }
          });
          cfRoomSession.selfMember = memberInstance;
        }
        yield import_core26.sagaEffects.fork(callSegmentWorker, __spreadProps(__spreadValues({}, options), {
          instance: cfRoomSession,
          action
        }));
        break;
      }
      case "call.state":
        cfRoomSession.emit(type, payload);
        break;
    }
  }
  let firstCallJoinedReceived = false;
  const isFirstCallJoinedorCallStateEvent = (action) => {
    if (action.type === "call.state") {
      return true;
    }
    if (action.type !== "call.joined") {
      return false;
    }
    if (!firstCallJoinedReceived) {
      const callId = action.payload.call_id;
      const originCallId = action.payload.origin_call_id;
      if (callId === originCallId) {
        firstCallJoinedReceived = true;
        return true;
      }
      return false;
    }
    return true;
  };
  while (true) {
    const action = yield import_core26.sagaEffects.take(
      swEventChannel,
      isFirstCallJoinedorCallStateEvent
    );
    yield import_core26.sagaEffects.fork(worker, action);
  }
  (0, import_core26.getLogger)().trace("fabricWorker ended");
};

// src/fabric/FabricRoomSession.ts
var FabricRoomSessionConnection = class _FabricRoomSessionConnection extends BaseRoomSessionConnection {
  constructor(options) {
    super(options);
    // this is "self" parameter required by the RPC, and is always "the member" on the 1st call segment
    __publicField(this, "_self");
    // this is "the member" on the last/active call segment
    __publicField(this, "_member");
    __publicField(this, "_currentLayoutEvent");
    //describes what are methods are allow for the user in a call segment
    __publicField(this, "_capabilities");
    this.initWorker();
  }
  get memberId() {
    var _a;
    return (_a = this._member) == null ? void 0 : _a.memberId;
  }
  set currentLayoutEvent(event) {
    this._currentLayoutEvent = event;
  }
  get currentLayoutEvent() {
    return this._currentLayoutEvent;
  }
  get currentLayout() {
    var _a;
    return (_a = this._currentLayoutEvent) == null ? void 0 : _a.layout;
  }
  get currentPosition() {
    var _a, _b;
    return (_b = (_a = this._currentLayoutEvent) == null ? void 0 : _a.layout.layers.find(
      (layer) => layer.member_id === this.memberId
    )) == null ? void 0 : _b.position;
  }
  get capabilities() {
    return this._capabilities;
  }
  set capabilities(capabilities) {
    this._capabilities = capabilities;
  }
  get selfMember() {
    return this._self;
  }
  set selfMember(member) {
    this._self = member;
  }
  set member(member) {
    this._member = member;
  }
  get member() {
    return this._member;
  }
  initWorker() {
    this.runWorker("fabricWorker", {
      worker: fabricWorker
    });
    this.runWorker("makeAudioElement", {
      worker: makeAudioElementSaga({
        speakerId: this.options.speakerId
      })
    });
  }
  join() {
    return __async(this, null, function* () {
      var _a, _b;
      if (this.options.attach) {
        this.options.prevCallId = (_b = (_a = getStorage()) == null ? void 0 : _a.getItem(PREVIOUS_CALLID_STORAGE_KEY)) != null ? _b : void 0;
      }
      this.logger.debug(
        `Tying to reattach to previuos call? ${!!this.options.prevCallId} - prevCallId: ${this.options.prevCallId}`
      );
      return __superGet(_FabricRoomSessionConnection.prototype, this, "invite").call(this);
    });
  }
  executeAction(params, options = {}) {
    var _a, _b, _c;
    const { method, channel, memberId, extraParams = {} } = params;
    const targetMember = memberId ? this.instanceMap.get(memberId) : this.member;
    if (!targetMember) throw new Error("No target param found to execute");
    return this.execute(
      {
        method,
        params: __spreadValues(__spreadProps(__spreadValues({}, channel && { channels: [channel] }), {
          self: {
            member_id: (_a = this.selfMember) == null ? void 0 : _a.id,
            call_id: (_b = this.selfMember) == null ? void 0 : _b.callId,
            node_id: (_c = this.selfMember) == null ? void 0 : _c.nodeId
          },
          target: {
            member_id: targetMember.id,
            call_id: targetMember.callId,
            node_id: targetMember.nodeId
          }
        }), extraParams)
      },
      options
    );
  }
  /** @internal */
  resume() {
    return __async(this, null, function* () {
      var _a;
      this.logger.warn(`[resume] Call ${this.id}`);
      if ((_a = this.peer) == null ? void 0 : _a.instance) {
        const { connectionState } = this.peer.instance;
        this.logger.debug(
          `[resume] connectionState for ${this.id} is '${connectionState}'`
        );
        if (["closed", "failed", "disconnected"].includes(connectionState)) {
          this.resuming = true;
          this.peer.restartIce();
        }
      }
    });
  }
  start() {
    return __async(this, null, function* () {
      return new Promise((resolve, reject) => __async(this, null, function* () {
        try {
          this.once("room.subscribed", (params) => {
            var _a;
            (_a = getStorage()) == null ? void 0 : _a.setItem(PREVIOUS_CALLID_STORAGE_KEY, params.call_id);
            resolve();
          });
          this.once("destroy", () => {
            var _a;
            (_a = getStorage()) == null ? void 0 : _a.removeItem(PREVIOUS_CALLID_STORAGE_KEY);
          });
          yield this.join();
        } catch (error) {
          this.logger.error("WSClient call start", error);
          reject(error);
        }
      }));
    });
  }
  audioMute(params) {
    return __async(this, null, function* () {
      var _a, _b;
      if (!params || params.memberId === this.member.id ? !((_a = this.capabilities) == null ? void 0 : _a.self.muteAudio.off) : !((_b = this.capabilities) == null ? void 0 : _b.member.muteAudio.off)) {
        throw Error("Missing audio mute capability");
      }
      return this.executeAction({
        method: "call.mute",
        channel: "audio",
        memberId: params == null ? void 0 : params.memberId
      });
    });
  }
  audioUnmute(params) {
    return __async(this, null, function* () {
      var _a, _b;
      if (!params || params.memberId === this.member.id ? !((_a = this.capabilities) == null ? void 0 : _a.self.muteAudio.on) : !((_b = this.capabilities) == null ? void 0 : _b.member.muteAudio.on)) {
        throw Error("Missing audio unmute capability");
      }
      return this.executeAction({
        method: "call.unmute",
        channel: "audio",
        memberId: params == null ? void 0 : params.memberId
      });
    });
  }
  videoMute(params) {
    return __async(this, null, function* () {
      var _a, _b;
      if (!params || params.memberId === this.member.id ? !((_a = this.capabilities) == null ? void 0 : _a.self.muteVideo.off) : !((_b = this.capabilities) == null ? void 0 : _b.member.muteVideo.on)) {
        throw Error("Missing video mute capability");
      }
      return this.executeAction({
        method: "call.mute",
        channel: "video",
        memberId: params == null ? void 0 : params.memberId
      });
    });
  }
  videoUnmute(params) {
    return __async(this, null, function* () {
      var _a, _b;
      if (!params || params.memberId === this.member.id ? !((_a = this.capabilities) == null ? void 0 : _a.self.muteVideo.on) : !((_b = this.capabilities) == null ? void 0 : _b.member.muteVideo.on)) {
        throw Error("Missing video unmute capability");
      }
      return this.executeAction({
        method: "call.unmute",
        channel: "video",
        memberId: params == null ? void 0 : params.memberId
      });
    });
  }
  deaf(params) {
    return __async(this, null, function* () {
      var _a, _b;
      if (!params || params.memberId === this.member.id ? !((_a = this.capabilities) == null ? void 0 : _a.self.deaf.on) : !((_b = this.capabilities) == null ? void 0 : _b.member.deaf.on)) {
        throw Error("Missing deaf capability");
      }
      return this.executeAction({
        method: "call.deaf",
        memberId: params == null ? void 0 : params.memberId
      });
    });
  }
  undeaf(params) {
    return __async(this, null, function* () {
      var _a, _b;
      if (!params || params.memberId === this.member.id ? !((_a = this.capabilities) == null ? void 0 : _a.self.deaf.off) : !((_b = this.capabilities) == null ? void 0 : _b.member.deaf.off)) {
        throw Error("Missing undeaf capability");
      }
      return this.executeAction({
        method: "call.undeaf",
        memberId: params == null ? void 0 : params.memberId
      });
    });
  }
  getLayouts() {
    return __async(this, null, function* () {
      return this.executeAction(
        {
          method: "call.layout.list"
        },
        {
          transformResolve: (payload) => ({
            layouts: payload.layouts
          })
        }
      );
    });
  }
  getMembers() {
    return __async(this, null, function* () {
      return this.executeAction(
        {
          method: "call.member.list"
        },
        {
          transformResolve: (payload) => ({
            members: payload.members
          })
        }
      );
    });
  }
  removeMember(params) {
    return __async(this, null, function* () {
      var _a;
      if (!((_a = this.capabilities) == null ? void 0 : _a.member.remove)) {
        throw Error("Missing setLayout capability");
      }
      if (!(params == null ? void 0 : params.memberId)) {
        throw new TypeError('Invalid or missing "memberId" argument');
      }
      return this.executeAction({
        method: "call.member.remove",
        memberId: params.memberId
      });
    });
  }
  setRaisedHand(params) {
    return __async(this, null, function* () {
      var _a, _b, _c, _d;
      const { raised = true, memberId } = params || {};
      if (memberId == this.member.id && raised ? !((_a = this.capabilities) == null ? void 0 : _a.self.raisehand.on) : !((_b = this.capabilities) == null ? void 0 : _b.member.raisehand.on)) {
        throw Error("Missing raisehand capability");
      }
      if (memberId == this.member.id && !raised ? !((_c = this.capabilities) == null ? void 0 : _c.self.raisehand.off) : !((_d = this.capabilities) == null ? void 0 : _d.member.raisehand.off)) {
        throw Error("Missing lowerhand capability");
      }
      return this.executeAction({
        method: raised ? "call.raisehand" : "call.lowerhand",
        memberId
      });
    });
  }
  setLayout(params) {
    return __async(this, null, function* () {
      var _a;
      if (!((_a = this.capabilities) == null ? void 0 : _a.setLayout)) {
        throw Error("Missing setLayout capability");
      }
      const extraParams = {
        layout: params.name,
        positions: params.positions
      };
      return this.executeAction({
        method: "call.layout.set",
        extraParams
      });
    });
  }
  setInputVolume(params) {
    return __async(this, null, function* () {
      var _a, _b;
      if (!params || params.memberId === this.member.id ? !((_a = this.capabilities) == null ? void 0 : _a.self.microphoneVolume) : !((_b = this.capabilities) == null ? void 0 : _b.member.microphoneVolume)) {
        throw Error("Missing setInputVolume capability");
      }
      return this.executeAction({
        method: "call.microphone.volume.set",
        memberId: params == null ? void 0 : params.memberId,
        extraParams: {
          volume: params == null ? void 0 : params.volume
        }
      });
    });
  }
  setOutputVolume(params) {
    return __async(this, null, function* () {
      var _a, _b;
      if (!params || params.memberId === this.member.id ? !((_a = this.capabilities) == null ? void 0 : _a.self.speakerVolume) : !((_b = this.capabilities) == null ? void 0 : _b.member.speakerVolume)) {
        throw Error("Missing setOutputVolume capability");
      }
      return this.executeAction({
        method: "video.member.set_output_volume",
        memberId: params == null ? void 0 : params.memberId,
        extraParams: {
          volume: params == null ? void 0 : params.volume
        }
      });
    });
  }
  setInputSensitivity(params) {
    return __async(this, null, function* () {
      var _a, _b;
      if (!params || params.memberId === this.member.id ? !((_a = this.capabilities) == null ? void 0 : _a.self.microphoneSensitivity) : !((_b = this.capabilities) == null ? void 0 : _b.member.microphoneSensitivity)) {
        throw Error("Missing setOutputVolume capability");
      }
      return this.executeAction({
        method: "call.microphone.sensitivity.set",
        memberId: params == null ? void 0 : params.memberId,
        extraParams: {
          value: params == null ? void 0 : params.value
        }
      });
    });
  }
  setPositions(params) {
    return __async(this, null, function* () {
      var _a, _b, _c, _d, _e;
      const positions = params.positions;
      if (positions && !Object.keys(positions).length) {
        throw new Error("Invalid positions");
      }
      if (Object.keys(positions).some(
        (p) => ["self", `${this.memberId}`].includes(p)
      ) ? !((_a = this.capabilities) == null ? void 0 : _a.self.position) : !((_b = this.capabilities) == null ? void 0 : _b.member.position)) {
        throw Error("Missing setPositions capability");
      }
      const targets = [];
      Object.entries(positions).forEach(([key, value]) => {
        const targetMember = key === "self" ? this.member : this.instanceMap.get(key);
        if (targetMember) {
          targets.push({
            target: {
              member_id: targetMember.id,
              call_id: targetMember.callId,
              node_id: targetMember.nodeId
            },
            position: value
          });
        }
      });
      if (!targets.length) {
        throw new Error("Invalid targets");
      }
      return this.execute({
        method: "call.member.position.set",
        params: {
          self: {
            member_id: (_c = this.selfMember) == null ? void 0 : _c.id,
            call_id: (_d = this.selfMember) == null ? void 0 : _d.callId,
            node_id: (_e = this.selfMember) == null ? void 0 : _e.nodeId
          },
          targets
        }
      });
    });
  }
  lock() {
    return __async(this, null, function* () {
      var _a;
      if (!((_a = this.capabilities) == null ? void 0 : _a.lock.on)) {
        throw Error("Missing lock capability");
      }
      return this.executeAction({
        method: "call.lock"
      });
    });
  }
  unlock() {
    return __async(this, null, function* () {
      var _a;
      if (!((_a = this.capabilities) == null ? void 0 : _a.lock.off)) {
        throw Error("Missing unlock capability");
      }
      return this.executeAction({
        method: "call.unlock"
      });
    });
  }
};
var isFabricRoomSession = (room) => {
  return room instanceof FabricRoomSessionConnection;
};
var createFabricRoomSessionObject = (params) => {
  const room = (0, import_core27.connect)({
    store: params.store,
    Component: FabricRoomSessionConnection
  })(params);
  return room;
};

// src/VideoOverlays.ts
var UserOverlay = class {
  constructor(options) {
    __publicField(this, "id");
    __publicField(this, "_domElement");
    __publicField(this, "_status");
    this.id = options.id;
    this._status = "hidden";
  }
  get userId() {
    return this.id.split(OVERLAY_PREFIX)[1];
  }
  get domElement() {
    return this._domElement;
  }
  set domElement(element) {
    (0, import_core28.getLogger)().debug("Setting domElement for ", this.id);
    this._domElement = element;
  }
  get status() {
    return this._status;
  }
  set status(status) {
    this._status = status;
  }
  hide() {
    if (!this.domElement) {
      return (0, import_core28.getLogger)().warn("Missing overlay to hide");
    }
    this.domElement.style.opacity = "0";
    this.status = "hidden";
  }
  show() {
    if (!this.domElement) {
      return (0, import_core28.getLogger)().warn("Missing overlay to show");
    }
    this.domElement.style.opacity = "1";
    this.status = "visible";
  }
};
var LocalVideoOverlay = class extends UserOverlay {
  constructor(options) {
    super(options);
    __publicField(this, "_mirrored");
    __publicField(this, "_room");
    this._mirrored = options.mirrorLocalVideoOverlay;
    this._room = options.room;
    this.fabricMemberVideoMutedHandler = this.fabricMemberVideoMutedHandler.bind(this);
    this.videoMemberVideoMutedHandler = this.videoMemberVideoMutedHandler.bind(this);
    this.attachListeners();
  }
  get userId() {
    return this.id.split(SDK_PREFIX)[1];
  }
  get mirrored() {
    return this._mirrored;
  }
  attachListeners() {
    if (isFabricRoomSession(this._room)) {
      this._room.on(
        "member.updated.videoMuted",
        this.fabricMemberVideoMutedHandler
      );
    } else if (isVideoRoomSession(this._room)) {
      this._room.on(
        "member.updated.videoMuted",
        this.videoMemberVideoMutedHandler
      );
    }
  }
  /** @internal */
  detachListeners() {
    if (isFabricRoomSession(this._room)) {
      this._room.off(
        "member.updated.videoMuted",
        this.fabricMemberVideoMutedHandler
      );
    } else if (isVideoRoomSession(this._room)) {
      this._room.off(
        "member.updated.videoMuted",
        this.videoMemberVideoMutedHandler
      );
    }
  }
  memberVideoMutedHandler(memberId, videoMuted) {
    try {
      if (memberId === this._room.memberId) {
        videoMuted ? this.hide() : this.show();
      }
    } catch (error) {
      (0, import_core28.getLogger)().error("Error handling videoMuted in LocalVideoOverlay", error);
    }
  }
  fabricMemberVideoMutedHandler(params) {
    this.memberVideoMutedHandler(
      params.member.member_id,
      params.member.video_muted
    );
  }
  videoMemberVideoMutedHandler(params) {
    this.memberVideoMutedHandler(params.member.id, params.member.video_muted);
  }
  setMediaStream(stream) {
    if (!this.domElement) {
      return (0, import_core28.getLogger)().warn("Missing local overlay to set the stream");
    }
    const localVideo = this.domElement.querySelector("video");
    if (localVideo) {
      localVideo.srcObject = stream;
    }
  }
  setMirror(mirror = this._mirrored) {
    if (!this.domElement || !this.domElement.firstChild) {
      return (0, import_core28.getLogger)().warn("Missing local overlay to set the mirror");
    }
    const videoEl = this.domElement.firstChild;
    videoEl.style.transform = mirror ? "scale(-1, 1)" : "scale(1, 1)";
    videoEl.style.webkitTransform = mirror ? "scale(-1, 1)" : "scale(1, 1)";
    this._mirrored = mirror;
  }
};

// src/utils/videoElement.ts
var buildVideo = () => {
  const video = document.createElement("video");
  video.muted = true;
  video.autoplay = true;
  video.playsInline = true;
  video.addEventListener("pause", () => {
    video.play().catch((error) => {
      (0, import_core29.getLogger)().error("Video Element Paused", video, error);
    });
  });
  return video;
};
var waitForVideoReady = ({ element }) => {
  return new Promise((resolve) => {
    element.addEventListener("canplay", function listener() {
      element.removeEventListener("canplay", listener);
      resolve();
    });
    element.addEventListener("resize", function listener() {
      element.removeEventListener("resize", listener);
      resolve();
    });
  });
};
var _getLocationStyles = ({
  x,
  y,
  width,
  height
}) => {
  return {
    top: `${y}%`,
    left: `${x}%`,
    width: `${width}%`,
    height: `${height}%`
  };
};
var _buildLayer = ({ location }) => {
  const { top, left, width, height } = _getLocationStyles(location);
  const layer = document.createElement("div");
  layer.style.position = "absolute";
  layer.style.overflow = "hidden";
  layer.style.top = top;
  layer.style.left = left;
  layer.style.width = width;
  layer.style.height = height;
  return layer;
};
var _updateLayer = ({
  location,
  element
}) => {
  const { top, left, width, height } = _getLocationStyles(location);
  element.style.top = top;
  element.style.left = left;
  element.style.width = width;
  element.style.height = height;
  return element;
};
var makeLayoutChangedHandler = (params) => {
  const {
    applyLocalVideoOverlay,
    applyMemberOverlay,
    overlayMap,
    localVideoOverlay,
    mirrorLocalVideoOverlay,
    rootElement
  } = params;
  return (params2) => __async(void 0, null, function* () {
    (0, import_core29.getLogger)().debug("Process layout.changed");
    try {
      const { layout, memberId, localStream } = params2;
      const { layers = [] } = layout;
      const mcuLayers = rootElement.querySelector(".mcuLayers");
      const fragment = document.createDocumentFragment();
      const currentOverlayIds = /* @__PURE__ */ new Set();
      if (applyLocalVideoOverlay) {
        const location = layers.find(({ member_id }) => member_id === memberId);
        const overlayId = localVideoOverlay.id;
        let myLayerEl = localVideoOverlay.domElement;
        currentOverlayIds.add(overlayId);
        if (!location) {
          (0, import_core29.getLogger)().warn("Local video overlay location not found");
          localVideoOverlay.status = "hidden";
          if (myLayerEl) {
            localVideoOverlay.hide();
          }
        } else {
          if (myLayerEl) {
            (0, import_core29.getLogger)().debug("Update local video overlay");
            _updateLayer({ location, element: myLayerEl });
          } else {
            (0, import_core29.getLogger)().debug("Build local video overlay");
            myLayerEl = _buildLayer({ location });
            myLayerEl.id = overlayId;
            const localVideo = buildVideo();
            localVideo.srcObject = localStream;
            localVideo.disablePictureInPicture = true;
            localVideo.style.width = "100%";
            localVideo.style.height = "100%";
            localVideo.style.pointerEvents = "none";
            localVideo.style.objectFit = "cover";
            myLayerEl.appendChild(localVideo);
            localVideoOverlay.domElement = myLayerEl;
            if (mirrorLocalVideoOverlay) {
              localVideoOverlay.setMirror();
            }
          }
          const hasVideo = localStream.getVideoTracks().filter((t) => t.enabled && t.readyState === "live").length > 0;
          if (hasVideo && location.visible) {
            localVideoOverlay.setMediaStream(localStream);
            localVideoOverlay.show();
          } else {
            localVideoOverlay.hide();
          }
          fragment.appendChild(myLayerEl);
        }
      }
      if (applyMemberOverlay) {
        layers.forEach((location) => {
          const memberIdInLocation = location.member_id;
          if (!memberIdInLocation) return;
          const overlayId = addOverlayPrefix(memberIdInLocation);
          currentOverlayIds.add(overlayId);
          let overlay = overlayMap.get(overlayId);
          if (overlay && overlay.domElement) {
            (0, import_core29.getLogger)().debug("Update an overlay for ", memberIdInLocation);
            _updateLayer({ location, element: overlay.domElement });
          } else {
            (0, import_core29.getLogger)().debug("Build an overlay for ", memberIdInLocation);
            overlay = new UserOverlay({ id: overlayId });
            overlayMap.set(overlayId, overlay);
            const newLayer = _buildLayer({ location });
            newLayer.id = `${overlayId}-${(0, import_core29.uuid)()}`;
            overlay.domElement = newLayer;
          }
          if (!location.visible) {
            overlay.hide();
          } else {
            overlay.show();
          }
          fragment.appendChild(overlay.domElement);
        });
      }
      overlayMap.forEach((overlay, overlayId) => {
        if (!currentOverlayIds.has(overlayId)) {
          if (overlay.domElement && overlay.domElement.parentNode) {
            overlay.domElement.parentNode.removeChild(overlay.domElement);
          }
          overlayMap.delete(overlayId);
        }
      });
      if (mcuLayers) {
        mcuLayers.innerHTML = "";
        mcuLayers.appendChild(fragment);
      }
    } catch (error) {
      (0, import_core29.getLogger)().error("Layout Changed Error", error);
    }
  });
};
var cleanupElement = (rootElement) => {
  while (rootElement.firstChild) {
    rootElement.removeChild(rootElement.firstChild);
  }
};
var setVideoMediaTrack = ({
  track,
  element
}) => {
  element.srcObject = new MediaStream([track]);
  track.addEventListener("ended", () => {
    element.srcObject = null;
    element.remove();
  });
};
var createRootElementResizeObserver = ({
  video,
  rootElement,
  paddingWrapper
}) => {
  const computePaddingWrapperWidth = (width, height) => {
    const nativeVideoRatio = video.videoWidth / video.videoHeight;
    const rootElementRatio = width / height;
    if (nativeVideoRatio > rootElementRatio) {
      return "100%";
    } else {
      return `${height * nativeVideoRatio}px`;
    }
  };
  const update = (0, import_core29.debounce)(
    ({ width, height }) => {
      const maxPaddingBottom = video.videoHeight / video.videoWidth * 100;
      if (paddingWrapper) {
        const pb = height / width * 100;
        paddingWrapper.style.paddingBottom = `${pb > maxPaddingBottom ? maxPaddingBottom : pb}%`;
        paddingWrapper.style.width = computePaddingWrapperWidth(width, height);
      }
    },
    100
  );
  const observer = new ResizeObserver((entries) => {
    entries.forEach((entry) => {
      if (entry.contentBoxSize) {
        const { inlineSize, blockSize } = Array.isArray(entry.contentBoxSize) ? entry.contentBoxSize[0] : entry.contentBoxSize;
        update({ width: inlineSize, height: blockSize });
      } else if (entry.contentRect) {
        update({
          width: entry.contentRect.width,
          height: entry.contentRect.height
        });
      }
    });
  });
  const onVideoResize = () => {
    const width = rootElement.clientWidth;
    const height = rootElement.clientHeight;
    update({ width, height });
  };
  return {
    start: () => {
      observer.observe(rootElement);
      video.addEventListener("resize", onVideoResize);
    },
    stop: () => {
      observer.disconnect();
      video.removeEventListener("resize", onVideoResize);
    }
  };
};

// src/buildVideoElement.ts
var buildVideoElement = (params) => __async(void 0, null, function* () {
  var _a;
  try {
    const {
      room,
      rootElement: element,
      applyLocalVideoOverlay = true,
      applyMemberOverlay = true,
      mirrorLocalVideoOverlay = true
    } = params;
    let hasVideoTrack = false;
    const overlayMap = /* @__PURE__ */ new Map();
    const id = (0, import_core30.uuid)();
    let rootElement;
    if (element) {
      rootElement = element;
    } else {
      rootElement = document.createElement("div");
      rootElement.id = `rootElement-${id}`;
    }
    const overlayId = addSDKPrefix(id);
    const localVideoOverlay = new LocalVideoOverlay({
      id: overlayId,
      mirrorLocalVideoOverlay,
      room
    });
    if (applyLocalVideoOverlay) {
      overlayMap.set(overlayId, localVideoOverlay);
    }
    const makeLayout = makeLayoutChangedHandler({
      applyLocalVideoOverlay,
      applyMemberOverlay,
      overlayMap,
      localVideoOverlay,
      mirrorLocalVideoOverlay,
      rootElement
    });
    const processLayoutChanged = (params2) => {
      var _a2;
      if (((_a2 = room.peer) == null ? void 0 : _a2.hasVideoSender) && room.localStream) {
        makeLayout({
          layout: params2.layout,
          localStream: room.localStream,
          memberId: room.memberId
        });
      } else {
        localVideoOverlay.hide();
      }
    };
    const layoutChangedHandler = (params2) => {
      (0, import_core30.getLogger)().debug("Received layout.changed - videoTrack", hasVideoTrack);
      if (hasVideoTrack) {
        processLayoutChanged(params2);
        return;
      }
    };
    const processVideoTrack = (track) => __async(void 0, null, function* () {
      hasVideoTrack = true;
      yield videoElementSetup({
        applyLocalVideoOverlay,
        applyMemberOverlay,
        rootElement,
        track
      });
      const roomCurrentLayoutEvent = room.currentLayoutEvent;
      if (roomCurrentLayoutEvent) {
        processLayoutChanged(roomCurrentLayoutEvent);
      }
    });
    const videoTrack = (_a = room.peer) == null ? void 0 : _a.remoteVideoTrack;
    if (videoTrack) {
      yield processVideoTrack(videoTrack);
    }
    const trackHandler = function(event) {
      return __async(this, null, function* () {
        if (event.track.kind === "video") {
          yield processVideoTrack(event.track);
        }
      });
    };
    const unsubscribe = () => {
      cleanupElement(rootElement);
      overlayMap.clear();
      room.overlayMap = overlayMap;
      if (isFabricRoomSession(room)) {
        room.off("track", trackHandler);
        room.off("layout.changed", layoutChangedHandler);
        room.off("destroy", unsubscribe);
      } else if (isVideoRoomSession(room)) {
        room.off("track", trackHandler);
        room.off("layout.changed", layoutChangedHandler);
        room.off("destroy", unsubscribe);
      }
      localVideoOverlay.detachListeners();
    };
    if (isFabricRoomSession(room)) {
      room.on("track", trackHandler);
      room.on("layout.changed", layoutChangedHandler);
      room.once("destroy", unsubscribe);
    } else if (isVideoRoomSession(room)) {
      room.on("track", trackHandler);
      room.on("layout.changed", layoutChangedHandler);
      room.once("destroy", unsubscribe);
    }
    room.overlayMap = overlayMap;
    room.localVideoOverlay = localVideoOverlay;
    return { element: rootElement, overlayMap, localVideoOverlay, unsubscribe };
  } catch (error) {
    (0, import_core30.getLogger)().error("Unable to build the video element");
    throw error;
  }
});
var videoElementSetup = (options) => __async(void 0, null, function* () {
  try {
    const { applyLocalVideoOverlay, applyMemberOverlay, track, rootElement } = options;
    const videoElement = buildVideo();
    setVideoMediaTrack({ element: videoElement, track });
    videoElement.style.width = "100%";
    videoElement.style.maxHeight = "100%";
    if (rootElement.querySelector(".mcuContent")) {
      (0, import_core30.getLogger)().debug("MCU Content already there");
      return;
    }
    const mcuWrapper = document.createElement("div");
    mcuWrapper.style.position = "absolute";
    mcuWrapper.style.top = "0";
    mcuWrapper.style.left = "0";
    mcuWrapper.style.right = "0";
    mcuWrapper.style.bottom = "0";
    mcuWrapper.appendChild(videoElement);
    const paddingWrapper = document.createElement("div");
    paddingWrapper.classList.add("paddingWrapper");
    paddingWrapper.style.paddingBottom = "56.25%";
    paddingWrapper.style.position = "relative";
    paddingWrapper.style.width = "100%";
    paddingWrapper.appendChild(mcuWrapper);
    let layersWrapper = null;
    if (applyLocalVideoOverlay || applyMemberOverlay) {
      layersWrapper = document.createElement("div");
      layersWrapper.classList.add("mcuLayers");
      layersWrapper.style.display = "none";
      paddingWrapper.appendChild(layersWrapper);
    }
    const relativeWrapper = document.createElement("div");
    relativeWrapper.classList.add("mcuContent");
    relativeWrapper.style.position = "relative";
    relativeWrapper.style.width = "100%";
    relativeWrapper.style.height = "100%";
    relativeWrapper.style.margin = "0 auto";
    relativeWrapper.style.display = "flex";
    relativeWrapper.style.alignItems = "center";
    relativeWrapper.style.justifyContent = "center";
    relativeWrapper.appendChild(paddingWrapper);
    rootElement.style.width = "100%";
    rootElement.style.height = "100%";
    rootElement.appendChild(relativeWrapper);
    (0, import_core30.getLogger)().debug("MCU readyState 1 >>", videoElement.readyState);
    if (videoElement.readyState === HTMLMediaElement.HAVE_NOTHING) {
      (0, import_core30.getLogger)().debug("Wait for the MCU to be ready");
      yield waitForVideoReady({ element: videoElement });
    }
    (0, import_core30.getLogger)().debug("MCU is ready..");
    const rootElementResizeObserver = createRootElementResizeObserver({
      rootElement,
      video: videoElement,
      paddingWrapper
    });
    rootElementResizeObserver.start();
    track.addEventListener("ended", () => {
      if (rootElementResizeObserver) {
        rootElementResizeObserver.stop();
      }
    });
    if (layersWrapper) {
      layersWrapper.style.display = "block";
    }
  } catch (error) {
    (0, import_core30.getLogger)().error("Handle video track error", error);
  }
});

// src/Client.ts
var ClientAPI = class extends import_core31.BaseClient {
  constructor() {
    super(...arguments);
    __publicField(this, "_videoManager");
    __publicField(this, "_chat");
    __publicField(this, "_pubSub");
  }
  get rooms() {
    return {
      makeRoomObject: (makeRoomOptions) => {
        const _a = makeRoomOptions, {
          rootElement,
          applyLocalVideoOverlay = true,
          applyMemberOverlay = true,
          mirrorLocalVideoOverlay = true,
          stopCameraWhileMuted = true,
          stopMicrophoneWhileMuted = true
        } = _a, options = __objRest(_a, [
          "rootElement",
          "applyLocalVideoOverlay",
          "applyMemberOverlay",
          "mirrorLocalVideoOverlay",
          "stopCameraWhileMuted",
          "stopMicrophoneWhileMuted"
        ]);
        const customSagas = [];
        customSagas.push(
          makeAudioElementSaga({
            speakerId: options.speakerId
          })
        );
        const room = createVideoRoomSessionObject(__spreadProps(__spreadValues({}, options), {
          store: this.store,
          customSagas
        }));
        if (rootElement) {
          try {
            buildVideoElement({
              applyLocalVideoOverlay,
              applyMemberOverlay,
              mirrorLocalVideoOverlay,
              room,
              rootElement
            });
          } catch (error) {
            this.logger.error("Unable to build the video element automatically");
          }
        }
        room.on("room.subscribed", (params) => {
          var _a2;
          const member = (_a2 = params.room_session.members) == null ? void 0 : _a2.find(
            (m) => m.id === room.memberId
          );
          if (member == null ? void 0 : member.audio_muted) {
            try {
              room.stopOutboundAudio();
            } catch (error) {
              this.logger.error("Error handling audio_muted", error);
            }
          }
          if (member == null ? void 0 : member.video_muted) {
            try {
              room.stopOutboundVideo();
            } catch (error) {
              this.logger.error("Error handling video_muted", error);
            }
          }
        });
        if (stopMicrophoneWhileMuted) {
          room.on("member.updated.audio_muted", ({ member }) => {
            try {
              if (member.id === room.memberId && "audio_muted" in member) {
                member.audio_muted ? room.stopOutboundAudio() : room.restoreOutboundAudio();
              }
            } catch (error) {
              this.logger.error("Error handling audio_muted", error);
            }
          });
        }
        if (stopCameraWhileMuted) {
          room.on("member.updated.video_muted", ({ member }) => {
            try {
              if (member.id === room.memberId && "video_muted" in member) {
                member.video_muted ? room.stopOutboundVideo() : room.restoreOutboundVideo();
              }
            } catch (error) {
              this.logger.error("Error handling video_muted", error);
            }
          });
        }
        return room;
      }
    };
  }
  get chat() {
    if (!this._chat) {
      this._chat = import_core31.Chat.createBaseChatObject({
        store: this.store
      });
    }
    return this._chat;
  }
  get pubSub() {
    if (!this._pubSub) {
      this._pubSub = import_core31.PubSub.createBasePubSubObject({
        store: this.store
      });
    }
    return this._pubSub;
  }
  /** @internal */
  get videoManager() {
    if (!this._videoManager) {
      this._videoManager = createVideoManagerObject(this.options);
    }
    return this._videoManager;
  }
  /**
   * Reauthenticate with the SignalWire network using a new token
   * For now it returns void since with an invalid token the server
   * will close the connection right away so we can hook on the session
   * events in case. Need to improve it.
   *
   * @internal
   */
  reauthenticate(token) {
    this.store.dispatch(import_core31.actions.reauthAction({ token }));
  }
};

// src/JWTSession.ts
var import_jwt_decode2 = __toESM(require("jwt-decode"));
var import_core33 = require("@signalwire/core");

// src/utils/CloseEvent.ts
var import_core32 = require("@signalwire/core");
var SwCloseEvent = typeof CloseEvent === "function" ? CloseEvent : import_core32.SWCloseEvent;

// src/JWTSession.ts
var JWTSession = class extends import_core33.BaseJWTSession {
  constructor(options) {
    var _a;
    let decodedJwt = {};
    try {
      decodedJwt = (0, import_jwt_decode2.default)(options.token, {
        header: true
      });
    } catch (e) {
      if (process.env.NODE_ENV !== "production") {
        (0, import_core33.getLogger)().debug("[JWTSession] error decoding the JWT");
      }
    }
    super(__spreadProps(__spreadValues({}, options), {
      host: (decodedJwt == null ? void 0 : decodedJwt.ch) || options.host
    }));
    this.options = options;
    __publicField(this, "WebSocketConstructor", WebSocket);
    __publicField(this, "CloseEventConstructor", SwCloseEvent);
    __publicField(this, "agent", "@signalwire/js/browser/3.28.1");
    __publicField(this, "tokenTyp");
    this.tokenTyp = (_a = decodedJwt.typ) != null ? _a : "VRT";
  }
  get allowReattach() {
    var _a;
    return ((_a = this.options) == null ? void 0 : _a.reattach) !== false && (this.isVRT() || this.isSAT());
  }
  retrieveRelayProtocol() {
    return __async(this, null, function* () {
      var _a, _b;
      if (!this.allowReattach) {
        return "";
      }
      const { protocolKey } = sessionStorageManager(this.options.token);
      if (protocolKey) {
        this.logger.trace("Search protocol for", protocolKey);
        return (_b = (_a = getStorage()) == null ? void 0 : _a.getItem(protocolKey)) != null ? _b : "";
      }
      return "";
    });
  }
  persistRelayProtocol() {
    return __async(this, null, function* () {
      var _a;
      if (!this.allowReattach) {
        return;
      }
      const { protocolKey } = sessionStorageManager(this.options.token);
      if (protocolKey) {
        this.logger.trace("Persist protocol", protocolKey, this.relayProtocol);
        (_a = getStorage()) == null ? void 0 : _a.setItem(protocolKey, this.relayProtocol);
      }
    });
  }
  retrieveSwAuthorizationState() {
    return __async(this, null, function* () {
      var _a, _b;
      const { authStateKey } = sessionStorageManager(this.options.token);
      if (authStateKey) {
        return (_b = (_a = getStorage()) == null ? void 0 : _a.getItem(authStateKey)) != null ? _b : "";
      }
      return "";
    });
  }
  persistSwAuthorizationState(state) {
    return __async(this, null, function* () {
      var _a;
      if (!this.allowReattach) {
        return;
      }
      const { authStateKey } = sessionStorageManager(this.options.token);
      if (authStateKey) {
        this.logger.trace("Persist auth state", authStateKey, state);
        (_a = getStorage()) == null ? void 0 : _a.setItem(authStateKey, state);
      }
    });
  }
  _onSocketClose(event) {
    var _a, _b, _c;
    if (this.status === "unknown" || this.status === "disconnected") {
      const { protocolKey, authStateKey, callIdKey } = sessionStorageManager(
        this.options.token
      );
      this.logger.debug("Cleaning up storage");
      if (protocolKey) {
        this.logger.debug("Remove protocolKey", protocolKey);
        (_a = getStorage()) == null ? void 0 : _a.removeItem(protocolKey);
      }
      if (authStateKey) {
        this.logger.debug("Remove authStateKey", authStateKey);
        (_b = getStorage()) == null ? void 0 : _b.removeItem(authStateKey);
      }
      if (callIdKey) {
        this.logger.debug("Remove callIdKey", callIdKey);
        (_c = getStorage()) == null ? void 0 : _c.removeItem(callIdKey);
      }
    }
    super._onSocketClose(event);
  }
  isVRT() {
    return this.tokenTyp === "VRT";
  }
  isSAT() {
    return this.tokenTyp === "SAT";
  }
};

// src/createClient.ts
var createClient = (userOptions) => {
  const baseUserOptions = __spreadProps(__spreadValues({}, userOptions), {
    emitter: (0, import_core34.getEventEmitter)()
  });
  const store = (0, import_core34.configureStore)({
    userOptions: baseUserOptions,
    SessionConstructor: JWTSession
  });
  const client = (0, import_core34.connect)({
    store,
    Component: ClientAPI
  })(baseUserOptions);
  return client;
};

// src/chat/Client.ts
var INTERCEPTED_METHODS = [
  "subscribe",
  "publish",
  "getMessages",
  "getMembers",
  "getMemberState",
  "getAllowedChannels",
  "setMemberState"
];
var Client2 = function(chatOptions) {
  const client = createClient(chatOptions);
  const createInterceptor = (prop) => {
    return (...params) => __async(this, null, function* () {
      yield client.connect();
      return client.chat[prop](...params);
    });
  };
  const interceptors = {
    _session: client,
    disconnect: () => client.disconnect()
  };
  return new Proxy(client.chat, {
    get(target, prop, receiver) {
      if (prop in interceptors) {
        return interceptors[prop];
      }
      if (INTERCEPTED_METHODS.includes(prop)) {
        return createInterceptor(prop);
      }
      return Reflect.get(target, prop, receiver);
    }
  });
};

// src/chat/index.ts
var import_core35 = require("@signalwire/core");

// src/pubSub/index.ts
var pubSub_exports = {};
__export(pubSub_exports, {
  Client: () => Client3,
  PubSubMessage: () => PubSubMessage
});
var import_core37 = require("@signalwire/core");

// src/utils/interfaces/video.ts
var import_core36 = require("@signalwire/core");
var INTERNAL_MEMBER_UPDATED_EVENTS = Object.keys(
  import_core36.INTERNAL_MEMBER_UPDATABLE_PROPS
).map((key) => {
  return `member.updated.${key}`;
});

// src/pubSub/Client.ts
var INTERCEPTED_METHODS2 = [
  "getAllowedChannels",
  "subscribe",
  "publish"
];
var Client3 = function(pubSubOptions) {
  const client = createClient(pubSubOptions);
  const createInterceptor = (prop) => {
    return (...params) => __async(this, null, function* () {
      yield client.connect();
      return client.pubSub[prop](...params);
    });
  };
  const interceptors = {
    _session: client,
    disconnect: () => client.disconnect()
  };
  return new Proxy(client.pubSub, {
    get(target, prop, receiver) {
      if (prop in interceptors) {
        return interceptors[prop];
      }
      if (INTERCEPTED_METHODS2.includes(prop)) {
        return createInterceptor(prop);
      }
      return Reflect.get(target, prop, receiver);
    }
  });
};

// src/pubSub/index.ts
var PubSubMessage = import_core37.PubSub.PubSubMessage;

// src/fabric/index.ts
var fabric_exports = {};
__export(fabric_exports, {
  SignalWire: () => SignalWire,
  isFabricRoomSession: () => isFabricRoomSession
});

// src/fabric/HTTPClient.ts
var import_jwt_decode3 = __toESM(require("jwt-decode"));
var import_core39 = require("@signalwire/core");

// src/fabric/createHttpClient.ts
var import_core38 = require("@signalwire/core");
function http(input, init) {
  return __async(this, null, function* () {
    const response = yield fetch(input, init);
    if (!response.ok) {
      if (response.status === 401) {
        throw new import_core38.AuthError(response.status, "Unauthorized");
      }
      let errorResponse;
      try {
        errorResponse = yield response.json();
      } catch (e) {
      }
      const errorMessage = (errorResponse == null ? void 0 : errorResponse.errors) ? JSON.stringify(errorResponse.errors) : "Not Found";
      throw new import_core38.HttpError(response.status, errorMessage, errorResponse);
    }
    try {
      response.parsedBody = yield response.json();
    } catch (e) {
    }
    return response;
  });
}
var createHttpClient = (_a, fetcher = http) => {
  var _b = _a, { baseUrl, timeout = 3e4 } = _b, globalOptions = __objRest(_b, ["baseUrl", "timeout"]);
  const apiClient = (path, options) => __async(void 0, null, function* () {
    const headers = __spreadValues(__spreadValues(__spreadValues({}, (options == null ? void 0 : options.body) ? { "Content-Type": "application/json" } : {}), globalOptions.headers), options == null ? void 0 : options.headers);
    const reqInit = getRequestInit(__spreadProps(__spreadValues(__spreadValues({}, globalOptions), options), {
      headers
    }));
    let timerId;
    if (timeout) {
      const controller = new AbortController();
      const signal = controller.signal;
      reqInit.signal = signal;
      timerId = setTimeout(() => {
        controller.abort();
      }, timeout);
    }
    try {
      const response = yield fetcher(
        getUrl({
          path,
          baseUrl,
          searchParams: options == null ? void 0 : options.searchParams
        }),
        reqInit
      );
      return { body: response.parsedBody };
    } catch (e) {
      throw e;
    } finally {
      timerId && clearTimeout(timerId);
    }
  });
  return apiClient;
};
var getBody = (body) => {
  return typeof body === "string" ? body : JSON.stringify(body);
};
var getRequestInit = (options) => {
  return Object.entries(options).reduce((reducer, [key, value]) => {
    if (key === "body") {
      return __spreadProps(__spreadValues({}, reducer), {
        body: getBody(value)
      });
    } else if (value != void 0) {
      return __spreadProps(__spreadValues({}, reducer), {
        [key]: value
      });
    }
    return reducer;
  }, {});
};
var getUrl = ({
  path,
  baseUrl,
  searchParams
}) => {
  const url = new URL(path, baseUrl);
  if (searchParams) {
    Object.entries(searchParams).forEach(([key, value]) => {
      if (value != void 0) {
        url.searchParams.append(key, value);
      }
    });
  }
  return url.toString();
};

// src/utils/paginatedResult.ts
function buildPaginatedResult(body, client) {
  const anotherPage = (url) => __async(this, null, function* () {
    if (!url) return Promise.resolve(void 0);
    const { body: body2 } = yield client(url);
    return buildPaginatedResult(body2, client);
  });
  return {
    data: body.data,
    self: () => __async(this, null, function* () {
      const { self } = body.links;
      return anotherPage(self);
    }),
    nextPage: () => __async(this, null, function* () {
      const { next } = body.links;
      return anotherPage(next);
    }),
    prevPage: () => __async(this, null, function* () {
      const { prev } = body.links;
      return anotherPage(prev);
    }),
    firstPage: () => __async(this, null, function* () {
      const { first } = body.links;
      return anotherPage(first);
    }),
    hasNext: Boolean(body.links.next),
    hasPrev: Boolean(body.links.prev)
  };
}

// src/utils/makeQueryParamsUrl.ts
function makeQueryParamsUrls(path, queryParams) {
  const queryString = queryParams.toString();
  return queryString ? `${path}?${queryString}` : path;
}

// src/fabric/utils/typeGuard.ts
var isGetAddressByNameParams = (obj) => {
  return obj && "name" in obj;
};
var isGetAddressByIdParams = (obj) => {
  return obj && "id" in obj;
};
var isGetAddressesResponse = (obj) => {
  return obj && "data" in obj;
};

// src/fabric/HTTPClient.ts
var HTTPClient = class {
  constructor(options) {
    this.options = options;
    __publicField(this, "httpClient");
    this.httpClient = createHttpClient({
      baseUrl: `https://${this.httpHost}`,
      headers: {
        Authorization: `Bearer ${this.options.token}`
      }
    });
  }
  get fetch() {
    return this.httpClient;
  }
  get httpHost() {
    let decodedJwt = {};
    try {
      decodedJwt = (0, import_jwt_decode3.default)(this.options.token, {
        header: true
      });
    } catch (e) {
      if (process.env.NODE_ENV !== "production") {
        (0, import_core39.getLogger)().debug("[JWTSession] error decoding the JWT");
      }
    }
    const host = this.options.host || (decodedJwt == null ? void 0 : decodedJwt.ch);
    if (!host) {
      return "fabric.signalwire.com";
    }
    return `fabric.${host.split(".").splice(1).join(".")}`;
  }
  getAddress(params) {
    return __async(this, null, function* () {
      let path = "/api/fabric/addresses";
      if (isGetAddressByNameParams(params)) {
        path = `${path}?name=${params.name}`;
      } else if (isGetAddressByIdParams(params)) {
        path = `${path}/${params.id}`;
      }
      const { body } = yield this.httpClient(path);
      if (isGetAddressesResponse(body)) {
        if (!body.data[0]) throw new import_core39.HttpError(404, "Not Found");
        return body.data[0];
      }
      return body;
    });
  }
  getAddresses(params) {
    return __async(this, null, function* () {
      const { type, displayName, pageSize, sortBy, sortOrder } = params || {};
      let path = "/api/fabric/addresses";
      const queryParams = new URLSearchParams();
      if (type) {
        queryParams.append("type", type);
      }
      if (displayName) {
        queryParams.append("display_name", displayName);
      }
      if (pageSize) {
        queryParams.append("page_size", pageSize.toString());
      }
      if (sortBy) {
        queryParams.append("sort_by", sortBy);
      }
      if (sortOrder) {
        queryParams.append("sort_order", sortOrder);
      }
      const queryUrl = makeQueryParamsUrls(path, queryParams);
      (0, import_core39.getLogger)().debug(`[getAddresses] query URL ${queryUrl}`);
      const { body } = yield this.httpClient(queryUrl);
      return buildPaginatedResult(body, this.httpClient);
    });
  }
  registerDevice(params) {
    return __async(this, null, function* () {
      const { deviceType, deviceToken } = params;
      const path = "/subscriber/devices";
      const { body } = yield this.httpClient(path, {
        method: "POST",
        body: {
          device_type: deviceType,
          device_token: deviceToken
        }
      });
      return body;
    });
  }
  unregisterDevice(params) {
    return __async(this, null, function* () {
      const { id } = params;
      const path = `/subscriber/devices/${id}`;
      yield this.httpClient(path, {
        method: "DELETE"
      });
    });
  }
  getSubscriberInfo() {
    return __async(this, null, function* () {
      let path = "/api/fabric/subscriber/info";
      const { body } = yield this.httpClient(path);
      return body;
    });
  }
};

// src/fabric/ConversationAPI.ts
var ConversationAPI = class {
  constructor(conversation, payload) {
    this.conversation = conversation;
    this.payload = payload;
  }
  get id() {
    return this.payload.id;
  }
  get addressId() {
    return this.payload.address_id;
  }
  get createdAt() {
    return this.payload.created_at;
  }
  get lastMessageAt() {
    return this.payload.last_message_at;
  }
  get metadata() {
    return this.payload.metadata;
  }
  get name() {
    return this.payload.name;
  }
  sendMessage(params) {
    return this.conversation.sendMessage({
      addressId: this.id,
      text: params.text
    });
  }
  getMessages(params) {
    return this.conversation.getConversationMessages(__spreadValues({
      addressId: this.id
    }, params));
  }
};

// src/fabric/Conversation.ts
var DEFAULT_CHAT_MESSAGES_PAGE_SIZE = 10;
var Conversation = class {
  constructor(options) {
    __publicField(this, "httpClient");
    __publicField(this, "wsClient");
    __publicField(this, "callbacks", /* @__PURE__ */ new Set());
    __publicField(this, "chatSubscriptions", {});
    this.httpClient = options.httpClient;
    this.wsClient = options.wsClient;
    this.wsClient.runWorker("conversationWorker", {
      worker: conversationWorker,
      initialState: {
        conversation: this
      }
    });
  }
  /** @internal */
  handleEvent(event) {
    if (event.subtype === "chat") {
      const chatCallbacks = this.chatSubscriptions[event.conversation_id];
      if (chatCallbacks == null ? void 0 : chatCallbacks.size) {
        chatCallbacks.forEach((cb) => cb(event));
      }
    }
    if (this.callbacks.size) {
      this.callbacks.forEach((callback) => {
        callback(event);
      });
    }
  }
  sendMessage(params) {
    return __async(this, null, function* () {
      try {
        const { addressId, text } = params;
        const path = "/api/fabric/messages";
        const { body } = yield this.httpClient.fetch(path, {
          method: "POST",
          body: {
            conversation_id: addressId,
            text
          }
        });
        return body;
      } catch (error) {
        throw new Error("Error sending message to conversation!", error);
      }
    });
  }
  getConversations(params) {
    return __async(this, null, function* () {
      try {
        const { pageSize } = params || {};
        const path = "/api/fabric/conversations";
        const queryParams = new URLSearchParams();
        if (pageSize) {
          queryParams.append("page_size", pageSize.toString());
        }
        const { body } = yield this.httpClient.fetch(
          makeQueryParamsUrls(path, queryParams)
        );
        const self = this;
        const data = body.data.map(
          (conversation) => new ConversationAPI(self, conversation)
        );
        return buildPaginatedResult(__spreadProps(__spreadValues({}, body), { data }), this.httpClient.fetch);
      } catch (error) {
        throw new Error("Error fetching the conversation history!", error);
      }
    });
  }
  getMessages(params) {
    return __async(this, null, function* () {
      try {
        const { pageSize } = params || {};
        const path = "/api/fabric/messages";
        const queryParams = new URLSearchParams();
        if (pageSize) {
          queryParams.append("page_size", pageSize.toString());
        }
        const { body } = yield this.httpClient.fetch(
          makeQueryParamsUrls(path, queryParams)
        );
        return buildPaginatedResult(
          body,
          this.httpClient.fetch
        );
      } catch (error) {
        throw new Error("Error fetching the conversation messages!", error);
      }
    });
  }
  getConversationMessages(params) {
    return __async(this, null, function* () {
      try {
        const { addressId, pageSize } = params || {};
        const path = `/api/fabric/conversations/${addressId}/messages`;
        const queryParams = new URLSearchParams();
        if (pageSize) {
          queryParams.append("page_size", pageSize.toString());
        }
        const { body } = yield this.httpClient.fetch(
          makeQueryParamsUrls(path, queryParams)
        );
        return buildPaginatedResult(
          body,
          this.httpClient.fetch
        );
      } catch (error) {
        throw new Error("Error fetching the conversation messages!", error);
      }
    });
  }
  getChatMessages(params) {
    return __async(this, null, function* () {
      const { addressId, pageSize = DEFAULT_CHAT_MESSAGES_PAGE_SIZE } = params;
      const fetchChatMessagesPage = (_0, ..._1) => __async(this, [_0, ..._1], function* (fetcherFn, cached = [], isDirectionNext = true) {
        var _a;
        const chatMessages = [...cached];
        const isValid = (item) => item.conversation_id === addressId && item.subtype === "chat";
        let conversationMessages;
        conversationMessages = yield fetcherFn == null ? void 0 : fetcherFn();
        let chatOnlyMessages = (_a = conversationMessages == null ? void 0 : conversationMessages.data.filter(isValid)) != null ? _a : [];
        let remaining = pageSize - chatMessages.length;
        for (let idx = 0; idx < chatOnlyMessages.length && idx < remaining; idx++) {
          chatMessages.push(chatOnlyMessages[idx]);
        }
        while (chatMessages.length < pageSize && (conversationMessages == null ? void 0 : conversationMessages.hasNext)) {
          conversationMessages = yield isDirectionNext ? conversationMessages == null ? void 0 : conversationMessages.nextPage() : conversationMessages == null ? void 0 : conversationMessages.prevPage();
          if (!conversationMessages || !conversationMessages.data.length) {
            break;
          }
          remaining = pageSize - chatMessages.length;
          chatOnlyMessages = conversationMessages.data.filter(isValid);
          for (let idx = 0; idx < chatOnlyMessages.length && idx < remaining; idx++) {
            chatMessages.push(chatOnlyMessages[idx]);
          }
        }
        let missingReturns = [];
        if (remaining < chatOnlyMessages.length) {
          missingReturns = chatOnlyMessages.slice(remaining);
        }
        return {
          data: chatMessages,
          hasNext: !!(conversationMessages == null ? void 0 : conversationMessages.hasNext) || !!cached.length,
          hasPrev: !!(conversationMessages == null ? void 0 : conversationMessages.hasPrev),
          nextPage: () => fetchChatMessagesPage(conversationMessages == null ? void 0 : conversationMessages.nextPage, missingReturns),
          prevPage: () => fetchChatMessagesPage(
            conversationMessages == null ? void 0 : conversationMessages.prevPage,
            missingReturns,
            false
          ),
          self: () => fetchChatMessagesPage(conversationMessages == null ? void 0 : conversationMessages.self, missingReturns),
          firstPage: () => fetchChatMessagesPage(
            conversationMessages == null ? void 0 : conversationMessages.firstPage,
            missingReturns
          )
        };
      });
      return fetchChatMessagesPage(
        () => this.getConversationMessages({
          addressId,
          pageSize
        })
      );
    });
  }
  subscribe(callback) {
    return __async(this, null, function* () {
      this.callbacks.add(callback);
      return {
        unsubscribe: () => this.callbacks.delete(callback)
      };
    });
  }
  subscribeChatMessages(params) {
    return __async(this, null, function* () {
      const { addressId, onMessage } = params;
      if (!(addressId in this.chatSubscriptions)) {
        this.chatSubscriptions[addressId] = /* @__PURE__ */ new Set();
      }
      this.chatSubscriptions[addressId].add(onMessage);
      return {
        unsubscribe: () => this.chatSubscriptions[addressId].delete(onMessage)
      };
    });
  }
  joinConversation(params) {
    return __async(this, null, function* () {
      try {
        const { addressId } = params;
        const path = "/api/fabric/conversations/join";
        const { body } = yield this.httpClient.fetch(
          path,
          {
            method: "POST",
            body: {
              conversation_id: addressId
            }
          }
        );
        return body;
      } catch (error) {
        throw new Error("Error joining a conversation!", error);
      }
    });
  }
};

// src/fabric/WSClient.ts
var import_core42 = require("@signalwire/core");

// src/fabric/IncomingCallManager.ts
var IncomingCallManager = class {
  constructor(options) {
    this.options = options;
    __publicField(this, "_client");
    __publicField(this, "_pendingInvites", {});
    __publicField(this, "_handlers", {});
    this._client = options.client;
  }
  _buildNotification(invite) {
    const accept = (params) => __async(this, null, function* () {
      return new Promise((resolve, reject2) => {
        delete this._pendingInvites[invite.callID];
        try {
          const call = this.options.buildInboundCall(invite, params);
          call.answer();
          resolve(call);
        } catch (e) {
          reject2(e);
        }
      });
    });
    const reject = () => {
      delete this._pendingInvites[invite.callID];
      return this.options.executeVertoBye(invite.callID, invite.nodeId);
    };
    return {
      invite: {
        details: invite,
        accept: (params) => accept(params),
        reject: () => reject()
      }
    };
  }
  setNotificationHandlers(handlers) {
    this._handlers.all = handlers.all;
    if (handlers.pushNotification && this._handlers.all != handlers.pushNotification || !handlers.pushNotification) {
      this._handlers.pushNotification = handlers.pushNotification;
    }
    if (handlers.websocket && this._handlers.all != handlers.websocket || !handlers.websocket) {
      this._handlers.websocket = handlers.websocket;
    }
  }
  handleIncomingInvite(incomingInvite) {
    var _a, _b;
    if (incomingInvite.callID in this._pendingInvites) {
      this._client.logger.debug(
        `skiping nottification for pending invite to callID: ${incomingInvite.callID}`
      );
      return;
    }
    this._pendingInvites[incomingInvite.callID] = incomingInvite;
    if (!(this._handlers.all || this._handlers[incomingInvite.source])) {
      this._client.logger.warn("Skiping nottification due to no listeners");
      return;
    }
    const notification = this._buildNotification(incomingInvite);
    (_b = (_a = this._handlers).all) == null ? void 0 : _b.call(_a, notification);
    const handler = this._handlers[incomingInvite.source];
    handler == null ? void 0 : handler(notification);
  }
};

// src/fabric/createWSClient.ts
var import_core41 = require("@signalwire/core");

// src/fabric/SATSession.ts
var import_core40 = require("@signalwire/core");
var SATSession = class extends JWTSession {
  constructor(options) {
    super(options);
    this.options = options;
    __publicField(this, "connectVersion", import_core40.UNIFIED_CONNECT_VERSION);
  }
  get signature() {
    if (this._rpcConnectResult) {
      const { authorization } = this._rpcConnectResult;
      return authorization.jti;
    }
    return void 0;
  }
  _checkTokenExpiration() {
    return __async(this, null, function* () {
    });
  }
  /**
   * Reauthenticate with the SignalWire Network using a newer SAT.
   * If the session has expired, this will reconnect it.
   * @return Promise<void>
   */
  reauthenticate() {
    return __async(this, null, function* () {
      this.logger.debug("Session Reauthenticate", {
        ready: this.ready,
        expired: this.expired
      });
      if (!this.ready || this.expired) {
        return this.connect();
      }
      const params = {
        project: this._rpcConnectResult.authorization.project_id,
        jwt_token: this.options.token
      };
      try {
        const reauthResponse = yield this.execute((0, import_core40.RPCReauthenticate)(params));
        this._rpcConnectResult = __spreadValues(__spreadValues({}, this._rpcConnectResult), reauthResponse);
      } catch (error) {
        throw error;
      }
    });
  }
};

// src/fabric/createWSClient.ts
var createWSClient = (options) => {
  const store = (0, import_core41.configureStore)({
    userOptions: options,
    SessionConstructor: SATSession
  });
  return __spreadProps(__spreadValues({}, options), { store });
};

// src/fabric/WSClient.ts
var WSClient = class extends import_core42.BaseClient {
  constructor(wsClientOptions) {
    const client = createWSClient(wsClientOptions);
    super(client);
    this.wsClientOptions = wsClientOptions;
    __publicField(this, "_incomingCallManager");
    __publicField(this, "_disconnected", false);
    this._incomingCallManager = new IncomingCallManager({
      client: this,
      buildInboundCall: this.buildInboundCall.bind(this),
      executeVertoBye: this.executeVertoBye.bind(this)
    });
    this.runWorker("wsClientWorker", {
      worker: wsClientWorker,
      initialState: {
        handleIncomingInvite: (invite) => {
          this._incomingCallManager.handleIncomingInvite(__spreadValues({
            source: "websocket"
          }, invite));
        }
      }
    });
  }
  makeFabricObject(makeRoomOptions) {
    const _a = makeRoomOptions, {
      rootElement,
      applyLocalVideoOverlay = true,
      applyMemberOverlay = true,
      stopCameraWhileMuted = true,
      stopMicrophoneWhileMuted = true,
      mirrorLocalVideoOverlay = true
    } = _a, options = __objRest(_a, [
      "rootElement",
      "applyLocalVideoOverlay",
      "applyMemberOverlay",
      "stopCameraWhileMuted",
      "stopMicrophoneWhileMuted",
      "mirrorLocalVideoOverlay"
    ]);
    const room = createFabricRoomSessionObject(__spreadProps(__spreadValues({}, options), {
      store: this.store
    }));
    if (rootElement) {
      try {
        buildVideoElement({
          applyLocalVideoOverlay,
          applyMemberOverlay,
          mirrorLocalVideoOverlay,
          room,
          rootElement
        });
      } catch (error) {
        this.logger.error("Unable to build the video element automatically");
      }
    }
    const joinMutedHandler = (params) => {
      var _a2;
      const member = (_a2 = params.room_session.members) == null ? void 0 : _a2.find(
        // @ts-expect-error FIXME:
        (m) => m.id === room.memberId || m.member_id === room.memberId
      );
      if (member == null ? void 0 : member.audio_muted) {
        try {
          room.stopOutboundAudio();
        } catch (error) {
          this.logger.error("Error handling audio_muted", error);
        }
      }
      if (member == null ? void 0 : member.video_muted) {
        try {
          room.stopOutboundVideo();
        } catch (error) {
          this.logger.error("Error handling video_muted", error);
        }
      }
    };
    room.on("room.subscribed", joinMutedHandler);
    if (stopMicrophoneWhileMuted) {
      room.on("member.updated.audioMuted", ({ member }) => {
        try {
          if (member.member_id === room.memberId && "audio_muted" in member) {
            member.audio_muted ? room.stopOutboundAudio() : room.restoreOutboundAudio();
          }
        } catch (error) {
          this.logger.error("Error handling audio_muted", error);
        }
      });
    }
    if (stopCameraWhileMuted) {
      room.on("member.updated.videoMuted", ({ member }) => {
        try {
          if (member.member_id === room.memberId && "video_muted" in member) {
            member.video_muted ? room.stopOutboundVideo() : room.restoreOutboundVideo();
          }
        } catch (error) {
          this.logger.error("Error handling video_muted", error);
        }
      });
    }
    return room;
  }
  buildOutboundCall(params) {
    var _a, _b, _c, _d, _e;
    const [pathname, query] = params.to.split("?");
    if (!pathname) {
      throw new Error("Invalid destination address");
    }
    let video = false;
    let negotiateVideo = false;
    const queryParams = new URLSearchParams(query);
    const channel = queryParams.get("channel");
    if (channel === "video") {
      video = true;
      negotiateVideo = true;
    }
    const call = this.makeFabricObject({
      audio: (_a = params.audio) != null ? _a : true,
      video: (_b = params.video) != null ? _b : video,
      negotiateAudio: (_c = params.negotiateAudio) != null ? _c : true,
      negotiateVideo: (_d = params.negotiateVideo) != null ? _d : negotiateVideo,
      rootElement: params.rootElement || this.wsClientOptions.rootElement,
      applyLocalVideoOverlay: true,
      applyMemberOverlay: true,
      stopCameraWhileMuted: true,
      stopMicrophoneWhileMuted: true,
      watchMediaPackets: false,
      destinationNumber: params.to,
      nodeId: params.nodeId,
      attach: (_e = params.attach) != null ? _e : false,
      disableUdpIceServers: params.disableUdpIceServers || false,
      userVariables: params.userVariables || this.wsClientOptions.userVariables
    });
    call.once("destroy", () => {
      this.logger.debug("RTC Connection Destroyed");
      call.destroy();
    });
    this.session.once("session.disconnected", () => {
      this.logger.debug("Session Disconnected");
      call.destroy();
      this.destroy();
    });
    call.attachPreConnectWorkers();
    return call;
  }
  buildInboundCall(payload, params) {
    var _a, _b, _c, _d;
    const call = this.makeFabricObject({
      audio: (_a = params.audio) != null ? _a : true,
      video: (_b = params.video) != null ? _b : true,
      negotiateAudio: (_c = params.negotiateAudio) != null ? _c : true,
      negotiateVideo: (_d = params.negotiateVideo) != null ? _d : true,
      rootElement: params.rootElement || this.wsClientOptions.rootElement,
      applyLocalVideoOverlay: true,
      applyMemberOverlay: true,
      stopCameraWhileMuted: true,
      stopMicrophoneWhileMuted: true,
      watchMediaPackets: false,
      nodeId: payload.nodeId,
      remoteSdp: payload.sdp,
      prevCallId: payload.callID,
      disableUdpIceServers: params.disableUdpIceServers || false,
      userVariables: params.userVariables || this.wsClientOptions.userVariables
    });
    call.once("destroy", () => {
      this.logger.debug("RTC Connection Destroyed");
      call.destroy();
    });
    this.session.once("session.disconnected", () => {
      this.logger.debug("Session Disconnected");
      call.destroy();
      this.destroy();
    });
    call.attachPreConnectWorkers();
    return call;
  }
  executeVertoBye(callId, nodeId) {
    return __async(this, null, function* () {
      try {
        return yield this.execute({
          method: "webrtc.verto",
          params: {
            callID: callId,
            node_id: nodeId,
            message: (0, import_core42.VertoBye)({
              cause: "USER_BUSY",
              causeCode: "17",
              dialogParams: { callID: callId }
            })
          }
        });
      } catch (error) {
        this.logger.warn("The call is not available anymore", callId);
        throw error;
      }
    });
  }
  executeVertoSubscribe(callId, nodeId) {
    return __async(this, null, function* () {
      try {
        return yield this.execute({
          method: "webrtc.verto",
          params: {
            callID: callId,
            node_id: nodeId,
            subscribe: [],
            message: (0, import_core42.VertoSubscribe)({
              sessid: callId,
              eventChannel: []
            })
          }
        });
      } catch (error) {
        this.logger.warn("The call is not available anymore", callId);
        throw error;
      }
    });
  }
  disconnect() {
    return new Promise((resolve, _reject) => {
      if (this._disconnected) {
        resolve();
      }
      this.session.once("session.disconnected", () => {
        this.destroy();
        resolve();
        this._disconnected = true;
      });
      super.disconnect();
    });
  }
  dial(params) {
    return __async(this, null, function* () {
      return new Promise((resolve, reject) => __async(this, null, function* () {
        try {
          const call = this.buildOutboundCall(params);
          resolve(call);
        } catch (error) {
          this.logger.error("Unable to connect and dial a call", error);
          reject(error);
        }
      }));
    });
  }
  reattach(params) {
    return __async(this, null, function* () {
      return new Promise((resolve, reject) => __async(this, null, function* () {
        try {
          const call = this.buildOutboundCall(__spreadProps(__spreadValues({}, params), { attach: true }));
          resolve(call);
        } catch (error) {
          this.logger.error("Unable to connect and reattach a call", error);
          reject(error);
        }
      }));
    });
  }
  handlePushNotification(params) {
    return new Promise(
      (resolve, reject) => __async(this, null, function* () {
        const { decrypted, type } = params;
        if (type !== "call_invite") {
          this.logger.warn("Unknown notification type", params);
          reject("Unknown notification type");
        }
        this.logger.debug("handlePushNotification", params);
        const {
          params: { params: payload },
          node_id: nodeId
        } = decrypted;
        try {
          try {
            yield this.executeVertoSubscribe(payload.callID, nodeId);
          } catch (error) {
            this.logger.warn("Verto Subscribe", error);
          }
          this._incomingCallManager.handleIncomingInvite(__spreadValues({
            source: "pushNotification",
            nodeId
          }, payload));
          resolve({ resultType: "inboundCall" });
        } catch (error) {
          reject(error);
        }
      })
    );
  }
  updateToken(token) {
    return new Promise((resolve, reject) => {
      this.session.once("session.auth_error", (error) => {
        reject(error);
      });
      this.session.once("session.connected", () => {
        resolve();
      });
      this.store.dispatch(import_core42.actions.reauthAction({ token }));
    });
  }
  /**
   * Mark the client as 'online' to receive calls over WebSocket
   */
  online(_0) {
    return __async(this, arguments, function* ({ incomingCallHandlers }) {
      this._incomingCallManager.setNotificationHandlers(incomingCallHandlers);
      return this.execute({
        method: "subscriber.online",
        params: {}
      });
    });
  }
  /**
   * Mark the client as 'offline' to receive calls over WebSocket
   */
  offline() {
    this._incomingCallManager.setNotificationHandlers({});
    return this.execute({
      method: "subscriber.offline",
      params: {}
    });
  }
};

// src/fabric/SignalWire.ts
var SignalWire = /* @__PURE__ */ (() => {
  let instance = null;
  return (params) => {
    if (!instance) {
      instance = new Promise((resolve, reject) => __async(void 0, null, function* () {
        try {
          const wsClient = new WSClient(params);
          const httpClient = new HTTPClient(params);
          const conversation = new Conversation({ httpClient, wsClient });
          yield wsClient.connect();
          resolve({
            registerDevice: httpClient.registerDevice.bind(httpClient),
            unregisterDevice: httpClient.unregisterDevice.bind(httpClient),
            getSubscriberInfo: httpClient.getSubscriberInfo.bind(httpClient),
            disconnect: () => __async(void 0, null, function* () {
              yield wsClient.disconnect();
              instance = null;
            }),
            online: wsClient.online.bind(wsClient),
            offline: wsClient.offline.bind(wsClient),
            dial: wsClient.dial.bind(wsClient),
            reattach: wsClient.reattach.bind(wsClient),
            handlePushNotification: wsClient.handlePushNotification.bind(wsClient),
            updateToken: wsClient.updateToken.bind(wsClient),
            address: {
              getAddresses: httpClient.getAddresses.bind(httpClient),
              getAddress: httpClient.getAddress.bind(httpClient)
            },
            conversation: {
              getConversations: conversation.getConversations.bind(conversation),
              getMessages: conversation.getMessages.bind(conversation),
              getConversationMessages: conversation.getConversationMessages.bind(conversation),
              subscribe: conversation.subscribe.bind(conversation),
              sendMessage: conversation.sendMessage.bind(conversation),
              join: conversation.joinConversation.bind(conversation)
            },
            chat: {
              getMessages: conversation.getChatMessages.bind(conversation),
              subscribe: conversation.subscribeChatMessages.bind(conversation),
              sendMessage: conversation.sendMessage.bind(conversation),
              join: conversation.joinConversation.bind(conversation)
            },
            // @ts-expect-error For debugging purposes
            on: wsClient.on.bind(wsClient),
            off: wsClient.off.bind(wsClient),
            __httpClient: httpClient,
            __wsClient: wsClient
          });
        } catch (error) {
          reject(error);
        }
      })).catch((error) => {
        instance = null;
        throw error;
      });
    }
    return instance;
  };
})();

// src/video/index.ts
var video_exports = {};
__export(video_exports, {
  RoomSession: () => RoomSession,
  createClient: () => createClient,
  createRoomObject: () => createRoomObject,
  isVideoRoomSession: () => isVideoRoomSession,
  joinRoom: () => joinRoom
});

// src/createRoomObject.ts
var import_core43 = require("@signalwire/core");
var VIDEO_CONSTRAINTS = {
  aspectRatio: { ideal: 16 / 9 }
};
var createRoomObject = (roomOptions) => {
  return new Promise((resolve, reject) => __async(void 0, null, function* () {
    const _a = roomOptions, {
      audio = true,
      video = true,
      iceServers,
      rootElementId,
      applyLocalVideoOverlay = true,
      autoJoin = false,
      stopCameraWhileMuted = true,
      stopMicrophoneWhileMuted = true,
      speakerId
    } = _a, userOptions = __objRest(_a, [
      "audio",
      "video",
      "iceServers",
      "rootElementId",
      "applyLocalVideoOverlay",
      "autoJoin",
      "stopCameraWhileMuted",
      "stopMicrophoneWhileMuted",
      "speakerId"
    ]);
    const client = createClient(__spreadValues({}, userOptions));
    yield client.connect();
    if (!client) {
      return;
    }
    let rootElement;
    if (rootElementId) {
      const el = document.getElementById(rootElementId);
      if (el) {
        rootElement = el;
      } else {
        rootElement = document.body;
        (0, import_core43.getLogger)().warn(
          `We couldn't find an element with id: ${rootElementId}: using 'document.body' instead.`
        );
      }
    }
    const roomObject = client.rooms.makeRoomObject({
      audio,
      video: video === true ? VIDEO_CONSTRAINTS : video,
      negotiateAudio: true,
      negotiateVideo: true,
      iceServers,
      rootElement,
      applyLocalVideoOverlay,
      stopCameraWhileMuted,
      stopMicrophoneWhileMuted,
      speakerId
    });
    roomObject.once("destroy", () => {
      roomObject.emit("room.left");
      client.disconnect();
    });
    const join = () => {
      return new Promise((resolve2, reject2) => __async(void 0, null, function* () {
        try {
          roomObject.once("room.subscribed", (_payload) => {
            resolve2(roomObject);
          });
          yield roomObject.join();
        } catch (error) {
          (0, import_core43.getLogger)().error("Join", error);
          client.disconnect();
          reject2(error);
        }
      }));
    };
    const room = new Proxy(roomObject, {
      get(target, prop, receiver) {
        if (prop === "join") {
          return join;
        }
        return Reflect.get(target, prop, receiver);
      }
    });
    if (autoJoin) {
      try {
        yield room.join();
        resolve(room);
      } catch (error) {
        reject(error);
      }
    } else {
      resolve(room);
    }
  }));
};

// src/joinRoom.ts
var joinRoom = (roomOptions) => {
  return createRoomObject(__spreadProps(__spreadValues({}, roomOptions), {
    autoJoin: true
  }));
};

// src/video/RoomSession.ts
var import_core44 = require("@signalwire/core");
var UNSAFE_PROP_ACCESS = [
  "audioMute",
  "audioUnmute",
  "deaf",
  "getLayouts",
  "getMembers",
  "getRecordings",
  "hideVideoMuted",
  "leave",
  "removerMember",
  "restoreOutboundAudio",
  "restoreOutboundVideo",
  "setInputSensitivity",
  "setInputVolume",
  "setLayout",
  "setPositions",
  "setMemberPosition",
  "setOutputVolume",
  "showVideoMuted",
  "startRecording",
  "stopOutboundAudio",
  "stopOutboundVideo",
  "undeaf",
  "videoMute",
  "videoUnmute",
  "setMicrophoneVolume",
  "setSpeakerVolume",
  "getMeta",
  "setMeta",
  "updateMeta",
  "deleteMeta",
  "getMemberMeta",
  "setMemberMeta",
  "updateMemberMeta",
  "deleteMemberMeta",
  "promote",
  "demote",
  "lock",
  "unlock"
];
var REQUIRED_EVENTS = [
  "member.joined",
  "layout.changed"
];
var noop2 = () => {
};
var RoomSession = function(roomOptions) {
  const _a = roomOptions, {
    audio: audioFromConstructor = true,
    video: videoFromConstructor = true,
    iceServers,
    rootElement,
    applyLocalVideoOverlay = true,
    mirrorLocalVideoOverlay = false,
    stopCameraWhileMuted = true,
    stopMicrophoneWhileMuted = true,
    speakerId,
    destinationNumber,
    localStream,
    watchMediaPackets,
    watchMediaPacketsTimeout,
    disableUdpIceServers = false
  } = _a, userOptions = __objRest(_a, [
    "audio",
    "video",
    "iceServers",
    "rootElement",
    "applyLocalVideoOverlay",
    "mirrorLocalVideoOverlay",
    "stopCameraWhileMuted",
    "stopMicrophoneWhileMuted",
    "speakerId",
    "destinationNumber",
    "localStream",
    "watchMediaPackets",
    "watchMediaPacketsTimeout",
    "disableUdpIceServers"
  ]);
  const deprecatedParams = ["audio", "video"];
  deprecatedParams.forEach((param) => {
    if (param in roomOptions) {
      (0, import_core44.getLogger)().warn(
        `The '${param}' parameter on the RoomSession constructor is deprecated. Set it on the '.join()' function instead.`
      );
    }
  });
  const allowReattach = (roomOptions == null ? void 0 : roomOptions.reattach) !== false;
  const { callIdKey } = sessionStorageManager(userOptions.token);
  const reattachManager = {
    joined: ({ call_id }) => {
      var _a2;
      if (allowReattach && callIdKey) {
        (_a2 = getStorage()) == null ? void 0 : _a2.setItem(callIdKey, call_id);
      }
    },
    init: () => {
      if (allowReattach) {
        room.on("room.subscribed", reattachManager.joined);
      }
      room.options.prevCallId = reattachManager.getPrevCallId();
    },
    destroy: () => {
      var _a2;
      if (!allowReattach) {
        return;
      }
      room.off("room.subscribed", reattachManager.joined);
      if (callIdKey) {
        (_a2 = getStorage()) == null ? void 0 : _a2.removeItem(callIdKey);
      }
    },
    getPrevCallId: () => {
      var _a2, _b;
      if (!allowReattach || !callIdKey) {
        return;
      }
      return (_b = (_a2 = getStorage()) == null ? void 0 : _a2.getItem(callIdKey)) != null ? _b : void 0;
    }
  };
  const client = createClient(userOptions);
  const room = client.rooms.makeRoomObject({
    // audio,
    // video: video === true ? VIDEO_CONSTRAINTS : video,
    negotiateAudio: true,
    negotiateVideo: true,
    iceServers,
    rootElement,
    applyLocalVideoOverlay,
    mirrorLocalVideoOverlay,
    stopCameraWhileMuted,
    stopMicrophoneWhileMuted,
    speakerId,
    destinationNumber,
    localStream,
    watchMediaPackets,
    watchMediaPacketsTimeout,
    prevCallId: reattachManager.getPrevCallId(),
    disableUdpIceServers
  });
  room.once("destroy", () => {
    room.emit("room.left", { reason: room.leaveReason });
    reattachManager.destroy();
    client.disconnect();
  });
  client.session.once("session.disconnected", () => {
    room.destroy();
  });
  const join = (params) => {
    return new Promise((resolve, reject) => __async(this, null, function* () {
      var _a2, _b;
      try {
        room.attachPreConnectWorkers();
        yield client.connect();
        const audio = (_a2 = params == null ? void 0 : params.audio) != null ? _a2 : audioFromConstructor;
        const video = (_b = params == null ? void 0 : params.video) != null ? _b : videoFromConstructor;
        const authState = client._sessionAuthState;
        (0, import_core44.getLogger)().debug("getJoinMediaParams authState?", authState);
        if (authState && authState.type === "video") {
          const mediaOptions = getJoinMediaParams(__spreadValues({
            authState,
            // constructor values override the send
            sendAudio: Boolean(audio),
            sendVideo: Boolean(video)
          }, params));
          if (!checkMediaParams(mediaOptions)) {
            client.disconnect();
            return reject(
              new Error(
                `Invalid arguments to join the room. The token used has join_as: '${authState.join_as}'. 
${JSON.stringify(params, null, 2)}
`
              )
            );
          }
          (0, import_core44.getLogger)().debug("Set mediaOptions", mediaOptions);
          room.updateMediaOptions({
            audio: mediaOptions.mustSendAudio ? audio || true : false,
            video: mediaOptions.mustSendVideo ? video || true : false,
            negotiateAudio: mediaOptions.mustRecvAudio,
            negotiateVideo: mediaOptions.mustRecvVideo
          });
        }
        room.once("room.subscribed", () => {
          resolve(room);
        });
        reattachManager.init();
        REQUIRED_EVENTS.forEach((event) => room.once(event, noop2));
        yield room.join();
      } catch (error) {
        (0, import_core44.getLogger)().error("RoomSession Join", error);
        client.disconnect();
        reject(error);
      }
    }));
  };
  const interceptors = {
    join
  };
  return new Proxy(room, {
    get(target, prop, receiver) {
      if (prop in interceptors) {
        return interceptors[prop];
      }
      if (!target.active && UNSAFE_PROP_ACCESS.includes(prop)) {
        throw new Error(
          `Tried to access the property/method "${prop}" before the room was connected. Please call roomSession.join() first.`
        );
      }
      return Reflect.get(target, prop, receiver);
    }
  });
};

// src/webrtc.ts
var webrtc_exports = {};
__export(webrtc_exports, {
  checkCameraPermissions: () => import_webrtc5.checkCameraPermissions,
  checkMicrophonePermissions: () => import_webrtc5.checkMicrophonePermissions,
  checkPermissions: () => import_webrtc5.checkPermissions,
  checkSpeakerPermissions: () => import_webrtc5.checkSpeakerPermissions,
  createCameraDeviceWatcher: () => import_webrtc5.createCameraDeviceWatcher,
  createDeviceWatcher: () => import_webrtc5.createDeviceWatcher,
  createMicrophoneAnalyzer: () => import_webrtc5.createMicrophoneAnalyzer,
  createMicrophoneDeviceWatcher: () => import_webrtc5.createMicrophoneDeviceWatcher,
  createSpeakerDeviceWatcher: () => import_webrtc5.createSpeakerDeviceWatcher,
  enumerateDevices: () => import_webrtc5.enumerateDevices,
  enumerateDevicesByKind: () => import_webrtc5.enumerateDevicesByKind,
  getCameraDevices: () => import_webrtc5.getCameraDevices,
  getCameraDevicesWithPermissions: () => import_webrtc5.getCameraDevicesWithPermissions,
  getDevices: () => import_webrtc5.getDevices,
  getDevicesWithPermissions: () => import_webrtc5.getDevicesWithPermissions,
  getDisplayMedia: () => import_webrtc5.getDisplayMedia,
  getMicrophoneDevices: () => import_webrtc5.getMicrophoneDevices,
  getMicrophoneDevicesWithPermissions: () => import_webrtc5.getMicrophoneDevicesWithPermissions,
  getSpeakerDevices: () => import_webrtc5.getSpeakerDevices,
  getSpeakerDevicesWithPermissions: () => import_webrtc5.getSpeakerDevicesWithPermissions,
  getSupportedConstraints: () => import_webrtc5.getSupportedConstraints,
  getUserMedia: () => import_webrtc5.getUserMedia,
  requestPermissions: () => import_webrtc5.requestPermissions,
  setMediaElementSinkId: () => import_webrtc5.setMediaElementSinkId,
  stopStream: () => import_webrtc5.stopStream,
  stopTrack: () => import_webrtc5.stopTrack,
  supportsGetDisplayMedia: () => import_webrtc5.supportsGetDisplayMedia,
  supportsGetUserMedia: () => import_webrtc5.supportsGetUserMedia,
  supportsMediaDevices: () => import_webrtc5.supportsMediaDevices,
  supportsMediaOutput: () => import_webrtc5.supportsMediaOutput
});
var import_webrtc5 = require("@signalwire/webrtc");
//# sourceMappingURL=index.js.map
