import { BaseJWTSession, SessionOptions, SwAuthorizationState, type SWCloseEvent } from '@signalwire/core';
export declare class JWTSession extends BaseJWTSession {
    options: SessionOptions;
    WebSocketConstructor: {
        new (url: string | URL, protocols?: string | string[]): WebSocket;
        prototype: WebSocket;
        readonly CONNECTING: 0;
        readonly OPEN: 1;
        readonly CLOSING: 2;
        readonly CLOSED: 3;
    };
    CloseEventConstructor: typeof SWCloseEvent | {
        new (type: string, eventInitDict?: CloseEventInit): CloseEvent;
        prototype: CloseEvent;
    };
    agent: string;
    private tokenTyp;
    constructor(options: SessionOptions);
    get allowReattach(): boolean;
    retrieveRelayProtocol(): Promise<string>;
    persistRelayProtocol(): Promise<void>;
    protected retrieveSwAuthorizationState(): Promise<string>;
    protected persistSwAuthorizationState(state: SwAuthorizationState): Promise<void>;
    protected _onSocketClose(event: SWCloseEvent): void;
    private isVRT;
    private isSAT;
}
//# sourceMappingURL=JWTSession.d.ts.map