import { VideoRoomSession } from './video/VideoRoomSession';
import { FabricRoomSession } from './fabric/FabricRoomSession';
export type OverlayMap = Map<string, UserOverlay>;
interface UserOverlayOptions {
    id: string;
}
export type OverlayStatus = 'hidden' | 'visible';
export declare class UserOverlay {
    id: string;
    private _domElement;
    private _status;
    constructor(options: UserOverlayOptions);
    get userId(): string;
    get domElement(): HTMLDivElement | undefined;
    set domElement(element: HTMLDivElement | undefined);
    get status(): OverlayStatus;
    set status(status: OverlayStatus);
    hide(): void;
    show(): void;
}
interface LocalVideoOverlayOptions {
    id: string;
    mirrorLocalVideoOverlay: boolean;
    room: FabricRoomSession | VideoRoomSession;
}
export declare class LocalVideoOverlay extends UserOverlay {
    private _mirrored;
    private _room;
    constructor(options: LocalVideoOverlayOptions);
    get userId(): string;
    get mirrored(): boolean;
    private attachListeners;
    /** @internal */
    detachListeners(): void;
    private memberVideoMutedHandler;
    private fabricMemberVideoMutedHandler;
    private videoMemberVideoMutedHandler;
    setMediaStream(stream: MediaStream): void;
    setMirror(mirror?: boolean): void;
}
export {};
//# sourceMappingURL=VideoOverlays.d.ts.map