import { UserOptions } from '@signalwire/core';
import { Client } from './Client';
/**
 * With Video.createClient() you can establish a WebSocket connection
 * with SignalWire and interact with the client.
 *
 * ## Examples
 * Create a client
 *
 * @example
 * ```js
 * try {
 *   const client = Video.createClient({
 *     token: '<YourJWT>',
 *   })
 *
 *   await client.connect()
 *   // Your client is ready now..
 * } catch (error) {
 *   console.error('Error', error)
 * }
 * ```
 * @internal
 */
export declare const createClient: <RoomSessionType>(userOptions: UserOptions) => Client<RoomSessionType>;
//# sourceMappingURL=createClient.d.ts.map