import { type ConversationEventParams } from '@signalwire/core';
import { HTTPClient } from './HTTPClient';
import { WSClient } from './WSClient';
import type { GetMessagesParams, GetConversationsParams, GetConversationMessagesParams, SendConversationMessageParams, GetMessagesResult, GetConversationMessagesResult, SendConversationMessageResult, GetConversationChatMessageParams, GetConversationsResult, ConversationSubscribeCallback, ConversationChatMessagesSubscribeParams, ConversationChatMessagesSubscribeResult, GetConversationChatMessageResult, JoinConversationParams, JoinConversationResult, ConversationSubscribeResult } from './interfaces';
interface ConversationOptions {
    httpClient: HTTPClient;
    wsClient: WSClient;
}
export declare class Conversation {
    private httpClient;
    private wsClient;
    private callbacks;
    private chatSubscriptions;
    constructor(options: ConversationOptions);
    /** @internal */
    handleEvent(event: ConversationEventParams): void;
    sendMessage(params: SendConversationMessageParams): Promise<SendConversationMessageResult>;
    getConversations(params?: GetConversationsParams): Promise<GetConversationsResult>;
    getMessages(params?: GetMessagesParams): Promise<GetMessagesResult>;
    getConversationMessages(params: GetConversationMessagesParams): Promise<GetConversationMessagesResult>;
    getChatMessages(params: GetConversationChatMessageParams): Promise<GetConversationChatMessageResult>;
    subscribe(callback: ConversationSubscribeCallback): Promise<ConversationSubscribeResult>;
    subscribeChatMessages(params: ConversationChatMessagesSubscribeParams): Promise<ConversationChatMessagesSubscribeResult>;
    joinConversation(params: JoinConversationParams): Promise<JoinConversationResult>;
}
export {};
//# sourceMappingURL=Conversation.d.ts.map