import { type UserOptions } from '@signalwire/core';
import type { GetAddressesParams, RegisterDeviceParams, UnregisterDeviceParams, GetAddressParams, GetAddressResult, GetAddressesResult, RegisterDeviceResult, GetSubscriberInfoResult } from './interfaces';
import { CreateHttpClient } from './createHttpClient';
import { HTTPClientContract } from './interfaces/httpClient';
export declare class HTTPClient implements HTTPClientContract {
    options: UserOptions;
    private httpClient;
    constructor(options: UserOptions);
    get fetch(): CreateHttpClient;
    get httpHost(): string;
    getAddress(params: GetAddressParams): Promise<GetAddressResult>;
    getAddresses(params?: GetAddressesParams): Promise<GetAddressesResult>;
    registerDevice(params: RegisterDeviceParams): Promise<RegisterDeviceResult>;
    unregisterDevice(params: UnregisterDeviceParams): Promise<void>;
    getSubscriberInfo(): Promise<GetSubscriberInfoResult>;
}
//# sourceMappingURL=HTTPClient.d.ts.map