import { SessionOptions } from '@signalwire/core';
import { JWTSession } from '../JWTSession';
/**
 * SAT Session is for the Call Fabric SDK
 */
export declare class SATSession extends JWTSession {
    options: SessionOptions;
    connectVersion: {
        major: number;
        minor: number;
        revision: number;
    };
    constructor(options: SessionOptions);
    get signature(): string | undefined;
    _checkTokenExpiration(): Promise<void>;
    /**
     * Reauthenticate with the SignalWire Network using a newer SAT.
     * If the session has expired, this will reconnect it.
     * @return Promise<void>
     */
    reauthenticate(): Promise<void>;
}
//# sourceMappingURL=SATSession.d.ts.map