import { BaseClient } from '@signalwire/core';
import { DialParams, FabricRoomSession, OnlineParams, HandlePushNotificationParams, WSClientOptions, HandlePushNotificationResult } from './interfaces';
import { WSClientContract } from './interfaces/wsClient';
export declare class WSClient extends BaseClient<{}> implements WSClientContract {
    private wsClientOptions;
    private _incomingCallManager;
    private _disconnected;
    constructor(wsClientOptions: WSClientOptions);
    private makeFabricObject;
    private buildOutboundCall;
    private buildInboundCall;
    private executeVertoBye;
    private executeVertoSubscribe;
    disconnect(): Promise<void>;
    dial(params: DialParams): Promise<FabricRoomSession>;
    reattach(params: DialParams): Promise<FabricRoomSession>;
    handlePushNotification(params: HandlePushNotificationParams): Promise<HandlePushNotificationResult>;
    updateToken(token: string): Promise<void>;
    /**
     * Mark the client as 'online' to receive calls over WebSocket
     */
    online({ incomingCallHandlers }: OnlineParams): Promise<void>;
    /**
     * Mark the client as 'offline' to receive calls over WebSocket
     */
    offline(): Promise<void>;
}
//# sourceMappingURL=WSClient.d.ts.map