import { WSClientOptions } from './interfaces';
export declare const createWSClient: (options: WSClientOptions) => {
    store: {
        runSaga: <T>(saga: import("@redux-saga/types").Saga, args: {
            instance: T;
            runSaga: any;
        }) => import("@redux-saga/types").Task<any>;
        channels: import("@signalwire/core").InternalChannels;
        instanceMap: import("@signalwire/core").InstanceMap;
        sessionEmitter: import("eventemitter3").EventEmitter<import("@signalwire/core").ClientEvents, any>;
        dispatch: import("redux").Dispatch<import("redux").AnyAction>;
        getState(): any;
        subscribe(listener: () => void): import("redux").Unsubscribe;
        replaceReducer(nextReducer: import("redux").Reducer<any, import("redux").AnyAction>): void;
        [Symbol.observable](): import("redux").Observable<any>;
    };
    rootElement?: HTMLElement;
    incomingCallHandlers?: import("./interfaces").IncomingCallHandlers;
    userVariables?: Record<string, any>;
    devTools?: boolean | undefined;
    debug?: {
        logWsTraffic?: boolean;
    } | undefined;
    logger?: import("@signalwire/core").SDKLogger | undefined;
    host?: string | undefined;
    project?: string | undefined;
    token: string;
    contexts?: string[] | undefined;
    topics?: string[] | undefined;
    logLevel?: "trace" | "debug" | "info" | "warn" | "error" | "silent" | undefined;
    sessionChannel?: import("packages/core/src/redux/interfaces").SessionChannel | undefined;
    instanceMap?: import("@signalwire/core").InstanceMap | undefined;
};
//# sourceMappingURL=createWSClient.d.ts.map