import { CallJoinedEvent, CallJoinedEventParams, CallUpdatedEvent, CallUpdatedEventParams, FabricLayoutChangedEvent, FabricMemberJoinedEvent, FabricMemberJoinedEventParams, FabricMemberLeftEvent, FabricMemberLeftEventParams, FabricMemberTalkingEvent, FabricMemberTalkingEventParams, FabricMemberUpdatedEvent, FabricMemberUpdatedEventParams, InternalFabricMemberEntity, InternalFabricMemberEntityUpdated, InternalFabricRoomSessionEntity, InternalVideoMemberEntity, InternalVideoMemberEntityUpdated, InternalVideoRoomEntity, InternalVideoRoomSessionEntity, MapToPubSubShape, VideoLayoutChangedEvent, VideoMemberJoinedEvent, VideoMemberJoinedEventParams, VideoMemberLeftEvent, VideoMemberLeftEventParams, VideoMemberTalkingEvent, VideoMemberTalkingEventParams, VideoMemberUpdatedEvent, VideoMemberUpdatedEventParams, VideoRoomSubscribedEvent, VideoRoomSubscribedEventParams, VideoRoomUpdatedEvent, VideoRoomUpdatedEventParams } from '@signalwire/core';
/**
 * Map the InternalFabricMemberEntity to InternalVideoMemberEntity
 */
export declare const mapInternalFabricMemberToInternalVideoMemberEntity: (params: InternalFabricMemberEntity) => InternalVideoMemberEntity;
/**
 * Map the InternalFabricMemberEntityUpdated to InternalVideoMemberEntityUpdated
 */
export declare const mapInternalFabricMemberToInternalVideoMemberUpdatedEntity: (params: InternalFabricMemberEntityUpdated) => InternalVideoMemberEntityUpdated;
/**
 * Map InternalFabricRoomSessionEntity to InternalVideoRoomEntity
 */
export declare const mapInternalFabricRoomToInternalVideoRoomEntity: (params: InternalFabricRoomSessionEntity) => InternalVideoRoomEntity;
/**
 * Map InternalFabricRoomSessionEntity to InternalVideoRoomSessionEntity
 */
export declare const mapInternalFabricRoomToInternalVideoRoomSessionEntity: (params: InternalFabricRoomSessionEntity) => InternalVideoRoomSessionEntity;
/**
 * Map the "call.joined" event params to "video.room.subscribed" event params
 */
export declare const mapCallJoinedToRoomSubscribedEventParams: (params: CallJoinedEventParams) => VideoRoomSubscribedEventParams;
/**
 * Map the "call.joined" action to "video.room.subscribed" action
 */
export declare const mapCallJoinedToRoomSubscribedAction: (action: MapToPubSubShape<CallJoinedEvent>) => MapToPubSubShape<VideoRoomSubscribedEvent>;
/**
 * Map the "call.updated" event params to "video.room.updated" event params
 */
export declare const mapCallUpdatedToRoomUpdatedEventParams: (params: CallUpdatedEventParams) => VideoRoomUpdatedEventParams;
/**
 * Map the "call.updated" action to "video.room.updated" action
 */
export declare const mapCallUpdatedToRoomUpdatedEventAction: (action: MapToPubSubShape<CallUpdatedEvent>) => MapToPubSubShape<VideoRoomUpdatedEvent>;
/**
 * Map the "member.joined" and "member.left" event params
 * to "video.member.joined" and "video.member.left"  event params
 */
export declare const mapFabricMemberToVideoMemberJoinAndLeftEventParams: (params: FabricMemberJoinedEventParams | FabricMemberLeftEventParams) => VideoMemberJoinedEventParams | VideoMemberLeftEventParams;
/**
 * Map the "member.joined" and "member.left" actions
 * to "video.member.joined" and "video.member.left"  actions
 */
export declare const mapFabricMemberActionToVideoMemberJoinAndLeftAction: (action: MapToPubSubShape<FabricMemberJoinedEvent | FabricMemberLeftEvent>) => MapToPubSubShape<VideoMemberJoinedEvent | VideoMemberLeftEvent>;
/**
 * Map the "member.updated" event params to "video.member.updated"  event params
 */
export declare const mapFabricMemberEventToVideoMemberUpdatedEventParams: (params: FabricMemberUpdatedEventParams) => VideoMemberUpdatedEventParams;
/**
 * Map the "member.updated" action to "video.member.updated"  action
 */
export declare const mapFabricMemberActionToVideoMemberUpdatedAction: (action: MapToPubSubShape<FabricMemberUpdatedEvent>) => MapToPubSubShape<VideoMemberUpdatedEvent>;
/**
 * Map the "member.talking" event params to "video.member.talking"  event params
 */
export declare const mapFabricMemberToVideoMemberTalkingEventParams: (params: FabricMemberTalkingEventParams) => VideoMemberTalkingEventParams;
/**
 * Map the "member.talking" action to "video.member.talking"  action
 */
export declare const mapFabricMemberActionToVideoMemberTalkingAction: (action: MapToPubSubShape<FabricMemberTalkingEvent>) => MapToPubSubShape<VideoMemberTalkingEvent>;
/**
 * Map the "layout.changed" action to "video.layout.changed"  action
 */
export declare const mapFabricLayoutActionToVideoLayoutAction: (action: MapToPubSubShape<FabricLayoutChangedEvent>) => MapToPubSubShape<VideoLayoutChangedEvent>;
//# sourceMappingURL=helpers.d.ts.map