import type { VideoAuthorization } from '@signalwire/core';
import type { BaseRoomSessionJoinParams } from './interfaces';
type GetJoinMediaParamsOptions = BaseRoomSessionJoinParams & {
    authState: VideoAuthorization;
};
/**
 * getJoinMediaParams returns whether the Join method must send/recv
 * audio and video.
 * Based on values on the Auth block (media allowed and join_as type)
 * it matches the user's preferences and return an object that tells
 * if the negotiation has to include sendrecv/sendonly or recvonly
 * for audio and video.
 */
export declare const getJoinMediaParams: (options: GetJoinMediaParamsOptions) => {
    mustSendAudio: boolean;
    mustSendVideo: boolean;
    mustRecvAudio: boolean;
    mustRecvVideo: boolean;
};
export declare const checkMediaParams: (options: Record<string, boolean | undefined>) => boolean;
export declare const SDK_PREFIX = "sw-sdk-";
export declare const addSDKPrefix: (id: string) => string;
export declare const OVERLAY_PREFIX = "sw-overlay-";
export declare const addOverlayPrefix: (id: string) => string;
export {};
//# sourceMappingURL=roomSession.d.ts.map