import { InternalVideoLayout } from '@signalwire/core';
import { OverlayMap, LocalVideoOverlay } from '../VideoOverlays';
declare const buildVideo: () => HTMLVideoElement;
declare const waitForVideoReady: ({ element }: {
    element: HTMLVideoElement;
}) => Promise<void>;
interface MakeLayoutChangedHandlerParams {
    applyLocalVideoOverlay?: boolean;
    applyMemberOverlay?: boolean;
    overlayMap: OverlayMap;
    localVideoOverlay: LocalVideoOverlay;
    mirrorLocalVideoOverlay?: boolean;
    rootElement: HTMLElement;
}
interface LayoutChangedHandlerParams {
    layout: InternalVideoLayout;
    memberId: string;
    localStream: MediaStream;
}
declare const makeLayoutChangedHandler: (params: MakeLayoutChangedHandlerParams) => (params: LayoutChangedHandlerParams) => Promise<void>;
declare const cleanupElement: (rootElement: HTMLElement) => void;
declare const setVideoMediaTrack: ({ track, element, }: {
    track: MediaStreamTrack;
    element: HTMLVideoElement;
}) => void;
declare const createRootElementResizeObserver: ({ video, rootElement, paddingWrapper, }: {
    video: HTMLVideoElement;
    rootElement: HTMLElement;
    paddingWrapper: HTMLDivElement;
}) => {
    start: () => void;
    stop: () => void;
};
export { buildVideo, cleanupElement, makeLayoutChangedHandler, setVideoMediaTrack, waitForVideoReady, createRootElementResizeObserver, LocalVideoOverlay, };
//# sourceMappingURL=videoElement.d.ts.map