import { SDKWorker, InternalVideoMemberEntity, InternalVideoMemberUpdatedEvent, VideoMemberJoinedEvent, VideoMemberLeftEvent, VideoMemberUpdatedEvent, InternalVideoRoomJoinedEvent, MapToPubSubShape } from '@signalwire/core';
import { VideoRoomSession } from '../VideoRoomSession';
/**
 * List of action types this worker cares about.
 */
type MemberListUpdatedTargetActions = MapToPubSubShape<InternalVideoRoomJoinedEvent | InternalVideoMemberUpdatedEvent | VideoMemberJoinedEvent | VideoMemberLeftEvent | VideoMemberUpdatedEvent>;
type MemberList = Map<string, InternalVideoMemberEntity>;
export declare const getUpdatedMembers: ({ action, memberList, }: {
    action: MemberListUpdatedTargetActions;
    memberList: MemberList;
}) => InternalVideoMemberEntity[];
export declare const memberListUpdatedWorker: SDKWorker<VideoRoomSession>;
export {};
//# sourceMappingURL=memberListUpdatedWorker.d.ts.map